/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ElastigroupAwsBeanstalkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#beanstalk_environment_id ElastigroupAwsBeanstalk#beanstalk_environment_id}
    */
    readonly beanstalkEnvironmentId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#beanstalk_environment_name ElastigroupAwsBeanstalk#beanstalk_environment_name}
    */
    readonly beanstalkEnvironmentName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#desired_capacity ElastigroupAwsBeanstalk#desired_capacity}
    */
    readonly desiredCapacity: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#id ElastigroupAwsBeanstalk#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#instance_types_spot ElastigroupAwsBeanstalk#instance_types_spot}
    */
    readonly instanceTypesSpot: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#maintenance ElastigroupAwsBeanstalk#maintenance}
    */
    readonly maintenance?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#max_size ElastigroupAwsBeanstalk#max_size}
    */
    readonly maxSize: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#min_size ElastigroupAwsBeanstalk#min_size}
    */
    readonly minSize: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#name ElastigroupAwsBeanstalk#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#product ElastigroupAwsBeanstalk#product}
    */
    readonly product: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#region ElastigroupAwsBeanstalk#region}
    */
    readonly region: string;
    /**
    * deployment_preferences block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#deployment_preferences ElastigroupAwsBeanstalk#deployment_preferences}
    */
    readonly deploymentPreferences?: ElastigroupAwsBeanstalkDeploymentPreferences;
    /**
    * managed_actions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#managed_actions ElastigroupAwsBeanstalk#managed_actions}
    */
    readonly managedActions?: ElastigroupAwsBeanstalkManagedActions;
    /**
    * scheduled_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#scheduled_task ElastigroupAwsBeanstalk#scheduled_task}
    */
    readonly scheduledTask?: ElastigroupAwsBeanstalkScheduledTask[] | cdktf.IResolvable;
}
export interface ElastigroupAwsBeanstalkDeploymentPreferencesStrategy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#action ElastigroupAwsBeanstalk#action}
    */
    readonly action?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#should_drain_instances ElastigroupAwsBeanstalk#should_drain_instances}
    */
    readonly shouldDrainInstances?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAwsBeanstalkDeploymentPreferencesStrategyToTerraform(struct?: ElastigroupAwsBeanstalkDeploymentPreferencesStrategy | cdktf.IResolvable): any;
export declare function elastigroupAwsBeanstalkDeploymentPreferencesStrategyToHclTerraform(struct?: ElastigroupAwsBeanstalkDeploymentPreferencesStrategy | cdktf.IResolvable): any;
export declare class ElastigroupAwsBeanstalkDeploymentPreferencesStrategyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsBeanstalkDeploymentPreferencesStrategy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsBeanstalkDeploymentPreferencesStrategy | cdktf.IResolvable | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _shouldDrainInstances?;
    get shouldDrainInstances(): boolean | cdktf.IResolvable;
    set shouldDrainInstances(value: boolean | cdktf.IResolvable);
    resetShouldDrainInstances(): void;
    get shouldDrainInstancesInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class ElastigroupAwsBeanstalkDeploymentPreferencesStrategyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsBeanstalkDeploymentPreferencesStrategy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsBeanstalkDeploymentPreferencesStrategyOutputReference;
}
export interface ElastigroupAwsBeanstalkDeploymentPreferences {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#automatic_roll ElastigroupAwsBeanstalk#automatic_roll}
    */
    readonly automaticRoll?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#batch_size_percentage ElastigroupAwsBeanstalk#batch_size_percentage}
    */
    readonly batchSizePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#grace_period ElastigroupAwsBeanstalk#grace_period}
    */
    readonly gracePeriod?: number;
    /**
    * strategy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#strategy ElastigroupAwsBeanstalk#strategy}
    */
    readonly strategy?: ElastigroupAwsBeanstalkDeploymentPreferencesStrategy[] | cdktf.IResolvable;
}
export declare function elastigroupAwsBeanstalkDeploymentPreferencesToTerraform(struct?: ElastigroupAwsBeanstalkDeploymentPreferencesOutputReference | ElastigroupAwsBeanstalkDeploymentPreferences): any;
export declare function elastigroupAwsBeanstalkDeploymentPreferencesToHclTerraform(struct?: ElastigroupAwsBeanstalkDeploymentPreferencesOutputReference | ElastigroupAwsBeanstalkDeploymentPreferences): any;
export declare class ElastigroupAwsBeanstalkDeploymentPreferencesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsBeanstalkDeploymentPreferences | undefined;
    set internalValue(value: ElastigroupAwsBeanstalkDeploymentPreferences | undefined);
    private _automaticRoll?;
    get automaticRoll(): boolean | cdktf.IResolvable;
    set automaticRoll(value: boolean | cdktf.IResolvable);
    resetAutomaticRoll(): void;
    get automaticRollInput(): boolean | cdktf.IResolvable | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): number;
    set batchSizePercentage(value: number);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): number | undefined;
    private _gracePeriod?;
    get gracePeriod(): number;
    set gracePeriod(value: number);
    resetGracePeriod(): void;
    get gracePeriodInput(): number | undefined;
    private _strategy;
    get strategy(): ElastigroupAwsBeanstalkDeploymentPreferencesStrategyList;
    putStrategy(value: ElastigroupAwsBeanstalkDeploymentPreferencesStrategy[] | cdktf.IResolvable): void;
    resetStrategy(): void;
    get strategyInput(): cdktf.IResolvable | ElastigroupAwsBeanstalkDeploymentPreferencesStrategy[] | undefined;
}
export interface ElastigroupAwsBeanstalkManagedActionsPlatformUpdate {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#perform_at ElastigroupAwsBeanstalk#perform_at}
    */
    readonly performAt?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#time_window ElastigroupAwsBeanstalk#time_window}
    */
    readonly timeWindow?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#update_level ElastigroupAwsBeanstalk#update_level}
    */
    readonly updateLevel?: string;
}
export declare function elastigroupAwsBeanstalkManagedActionsPlatformUpdateToTerraform(struct?: ElastigroupAwsBeanstalkManagedActionsPlatformUpdateOutputReference | ElastigroupAwsBeanstalkManagedActionsPlatformUpdate): any;
export declare function elastigroupAwsBeanstalkManagedActionsPlatformUpdateToHclTerraform(struct?: ElastigroupAwsBeanstalkManagedActionsPlatformUpdateOutputReference | ElastigroupAwsBeanstalkManagedActionsPlatformUpdate): any;
export declare class ElastigroupAwsBeanstalkManagedActionsPlatformUpdateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsBeanstalkManagedActionsPlatformUpdate | undefined;
    set internalValue(value: ElastigroupAwsBeanstalkManagedActionsPlatformUpdate | undefined);
    private _performAt?;
    get performAt(): string;
    set performAt(value: string);
    resetPerformAt(): void;
    get performAtInput(): string | undefined;
    private _timeWindow?;
    get timeWindow(): string;
    set timeWindow(value: string);
    resetTimeWindow(): void;
    get timeWindowInput(): string | undefined;
    private _updateLevel?;
    get updateLevel(): string;
    set updateLevel(value: string);
    resetUpdateLevel(): void;
    get updateLevelInput(): string | undefined;
}
export interface ElastigroupAwsBeanstalkManagedActions {
    /**
    * platform_update block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#platform_update ElastigroupAwsBeanstalk#platform_update}
    */
    readonly platformUpdate?: ElastigroupAwsBeanstalkManagedActionsPlatformUpdate;
}
export declare function elastigroupAwsBeanstalkManagedActionsToTerraform(struct?: ElastigroupAwsBeanstalkManagedActionsOutputReference | ElastigroupAwsBeanstalkManagedActions): any;
export declare function elastigroupAwsBeanstalkManagedActionsToHclTerraform(struct?: ElastigroupAwsBeanstalkManagedActionsOutputReference | ElastigroupAwsBeanstalkManagedActions): any;
export declare class ElastigroupAwsBeanstalkManagedActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsBeanstalkManagedActions | undefined;
    set internalValue(value: ElastigroupAwsBeanstalkManagedActions | undefined);
    private _platformUpdate;
    get platformUpdate(): ElastigroupAwsBeanstalkManagedActionsPlatformUpdateOutputReference;
    putPlatformUpdate(value: ElastigroupAwsBeanstalkManagedActionsPlatformUpdate): void;
    resetPlatformUpdate(): void;
    get platformUpdateInput(): ElastigroupAwsBeanstalkManagedActionsPlatformUpdate | undefined;
}
export interface ElastigroupAwsBeanstalkScheduledTask {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#adjustment ElastigroupAwsBeanstalk#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#adjustment_percentage ElastigroupAwsBeanstalk#adjustment_percentage}
    */
    readonly adjustmentPercentage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#batch_size_percentage ElastigroupAwsBeanstalk#batch_size_percentage}
    */
    readonly batchSizePercentage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#cron_expression ElastigroupAwsBeanstalk#cron_expression}
    */
    readonly cronExpression?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#frequency ElastigroupAwsBeanstalk#frequency}
    */
    readonly frequency?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#grace_period ElastigroupAwsBeanstalk#grace_period}
    */
    readonly gracePeriod?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#is_enabled ElastigroupAwsBeanstalk#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#max_capacity ElastigroupAwsBeanstalk#max_capacity}
    */
    readonly maxCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#min_capacity ElastigroupAwsBeanstalk#min_capacity}
    */
    readonly minCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#scale_max_capacity ElastigroupAwsBeanstalk#scale_max_capacity}
    */
    readonly scaleMaxCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#scale_min_capacity ElastigroupAwsBeanstalk#scale_min_capacity}
    */
    readonly scaleMinCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#scale_target_capacity ElastigroupAwsBeanstalk#scale_target_capacity}
    */
    readonly scaleTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#start_time ElastigroupAwsBeanstalk#start_time}
    */
    readonly startTime?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#target_capacity ElastigroupAwsBeanstalk#target_capacity}
    */
    readonly targetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#task_type ElastigroupAwsBeanstalk#task_type}
    */
    readonly taskType: string;
}
export declare function elastigroupAwsBeanstalkScheduledTaskToTerraform(struct?: ElastigroupAwsBeanstalkScheduledTask | cdktf.IResolvable): any;
export declare function elastigroupAwsBeanstalkScheduledTaskToHclTerraform(struct?: ElastigroupAwsBeanstalkScheduledTask | cdktf.IResolvable): any;
export declare class ElastigroupAwsBeanstalkScheduledTaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsBeanstalkScheduledTask | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsBeanstalkScheduledTask | cdktf.IResolvable | undefined);
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _adjustmentPercentage?;
    get adjustmentPercentage(): string;
    set adjustmentPercentage(value: string);
    resetAdjustmentPercentage(): void;
    get adjustmentPercentageInput(): string | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): string;
    set batchSizePercentage(value: string);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): string | undefined;
    private _cronExpression?;
    get cronExpression(): string;
    set cronExpression(value: string);
    resetCronExpression(): void;
    get cronExpressionInput(): string | undefined;
    private _frequency?;
    get frequency(): string;
    set frequency(value: string);
    resetFrequency(): void;
    get frequencyInput(): string | undefined;
    private _gracePeriod?;
    get gracePeriod(): string;
    set gracePeriod(value: string);
    resetGracePeriod(): void;
    get gracePeriodInput(): string | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _maxCapacity?;
    get maxCapacity(): string;
    set maxCapacity(value: string);
    resetMaxCapacity(): void;
    get maxCapacityInput(): string | undefined;
    private _minCapacity?;
    get minCapacity(): string;
    set minCapacity(value: string);
    resetMinCapacity(): void;
    get minCapacityInput(): string | undefined;
    private _scaleMaxCapacity?;
    get scaleMaxCapacity(): string;
    set scaleMaxCapacity(value: string);
    resetScaleMaxCapacity(): void;
    get scaleMaxCapacityInput(): string | undefined;
    private _scaleMinCapacity?;
    get scaleMinCapacity(): string;
    set scaleMinCapacity(value: string);
    resetScaleMinCapacity(): void;
    get scaleMinCapacityInput(): string | undefined;
    private _scaleTargetCapacity?;
    get scaleTargetCapacity(): string;
    set scaleTargetCapacity(value: string);
    resetScaleTargetCapacity(): void;
    get scaleTargetCapacityInput(): string | undefined;
    private _startTime?;
    get startTime(): string;
    set startTime(value: string);
    resetStartTime(): void;
    get startTimeInput(): string | undefined;
    private _targetCapacity?;
    get targetCapacity(): string;
    set targetCapacity(value: string);
    resetTargetCapacity(): void;
    get targetCapacityInput(): string | undefined;
    private _taskType?;
    get taskType(): string;
    set taskType(value: string);
    get taskTypeInput(): string | undefined;
}
export declare class ElastigroupAwsBeanstalkScheduledTaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsBeanstalkScheduledTask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsBeanstalkScheduledTaskOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk spotinst_elastigroup_aws_beanstalk}
*/
export declare class ElastigroupAwsBeanstalk extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_elastigroup_aws_beanstalk";
    /**
    * Generates CDKTF code for importing a ElastigroupAwsBeanstalk resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ElastigroupAwsBeanstalk to import
    * @param importFromId The id of the existing ElastigroupAwsBeanstalk that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ElastigroupAwsBeanstalk to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_aws_beanstalk spotinst_elastigroup_aws_beanstalk} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ElastigroupAwsBeanstalkConfig
    */
    constructor(scope: Construct, id: string, config: ElastigroupAwsBeanstalkConfig);
    private _beanstalkEnvironmentId?;
    get beanstalkEnvironmentId(): string;
    set beanstalkEnvironmentId(value: string);
    resetBeanstalkEnvironmentId(): void;
    get beanstalkEnvironmentIdInput(): string | undefined;
    private _beanstalkEnvironmentName?;
    get beanstalkEnvironmentName(): string;
    set beanstalkEnvironmentName(value: string);
    resetBeanstalkEnvironmentName(): void;
    get beanstalkEnvironmentNameInput(): string | undefined;
    private _desiredCapacity?;
    get desiredCapacity(): number;
    set desiredCapacity(value: number);
    get desiredCapacityInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _instanceTypesSpot?;
    get instanceTypesSpot(): string[];
    set instanceTypesSpot(value: string[]);
    get instanceTypesSpotInput(): string[] | undefined;
    private _maintenance?;
    get maintenance(): string;
    set maintenance(value: string);
    resetMaintenance(): void;
    get maintenanceInput(): string | undefined;
    private _maxSize?;
    get maxSize(): number;
    set maxSize(value: number);
    get maxSizeInput(): number | undefined;
    private _minSize?;
    get minSize(): number;
    set minSize(value: number);
    get minSizeInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _product?;
    get product(): string;
    set product(value: string);
    get productInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    get regionInput(): string | undefined;
    private _deploymentPreferences;
    get deploymentPreferences(): ElastigroupAwsBeanstalkDeploymentPreferencesOutputReference;
    putDeploymentPreferences(value: ElastigroupAwsBeanstalkDeploymentPreferences): void;
    resetDeploymentPreferences(): void;
    get deploymentPreferencesInput(): ElastigroupAwsBeanstalkDeploymentPreferences | undefined;
    private _managedActions;
    get managedActions(): ElastigroupAwsBeanstalkManagedActionsOutputReference;
    putManagedActions(value: ElastigroupAwsBeanstalkManagedActions): void;
    resetManagedActions(): void;
    get managedActionsInput(): ElastigroupAwsBeanstalkManagedActions | undefined;
    private _scheduledTask;
    get scheduledTask(): ElastigroupAwsBeanstalkScheduledTaskList;
    putScheduledTask(value: ElastigroupAwsBeanstalkScheduledTask[] | cdktf.IResolvable): void;
    resetScheduledTask(): void;
    get scheduledTaskInput(): cdktf.IResolvable | ElastigroupAwsBeanstalkScheduledTask[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
