/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ElastigroupGkeConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#cluster_id ElastigroupGke#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#cluster_zone_name ElastigroupGke#cluster_zone_name}
    */
    readonly clusterZoneName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#desired_capacity ElastigroupGke#desired_capacity}
    */
    readonly desiredCapacity: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#draining_timeout ElastigroupGke#draining_timeout}
    */
    readonly drainingTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#fallback_to_ondemand ElastigroupGke#fallback_to_ondemand}
    */
    readonly fallbackToOndemand?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#id ElastigroupGke#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#instance_name_prefix ElastigroupGke#instance_name_prefix}
    */
    readonly instanceNamePrefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#instance_types_ondemand ElastigroupGke#instance_types_ondemand}
    */
    readonly instanceTypesOndemand?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#instance_types_preemptible ElastigroupGke#instance_types_preemptible}
    */
    readonly instanceTypesPreemptible?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#ip_forwarding ElastigroupGke#ip_forwarding}
    */
    readonly ipForwarding?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#max_size ElastigroupGke#max_size}
    */
    readonly maxSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#min_cpu_platform ElastigroupGke#min_cpu_platform}
    */
    readonly minCpuPlatform?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#min_size ElastigroupGke#min_size}
    */
    readonly minSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#name ElastigroupGke#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#node_image ElastigroupGke#node_image}
    */
    readonly nodeImage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#ondemand_count ElastigroupGke#ondemand_count}
    */
    readonly ondemandCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#optimization_windows ElastigroupGke#optimization_windows}
    */
    readonly optimizationWindows?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#preemptible_percentage ElastigroupGke#preemptible_percentage}
    */
    readonly preemptiblePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#provisioning_model ElastigroupGke#provisioning_model}
    */
    readonly provisioningModel?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#service_account ElastigroupGke#service_account}
    */
    readonly serviceAccount?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#should_utilize_commitments ElastigroupGke#should_utilize_commitments}
    */
    readonly shouldUtilizeCommitments?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#shutdown_script ElastigroupGke#shutdown_script}
    */
    readonly shutdownScript?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#startup_script ElastigroupGke#startup_script}
    */
    readonly startupScript?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#tags ElastigroupGke#tags}
    */
    readonly tags?: string[];
    /**
    * backend_services block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#backend_services ElastigroupGke#backend_services}
    */
    readonly backendServices?: ElastigroupGkeBackendServices[] | cdktf.IResolvable;
    /**
    * disk block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#disk ElastigroupGke#disk}
    */
    readonly disk?: ElastigroupGkeDisk[] | cdktf.IResolvable;
    /**
    * gpu block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#gpu ElastigroupGke#gpu}
    */
    readonly gpu?: ElastigroupGkeGpu[] | cdktf.IResolvable;
    /**
    * instance_types_custom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#instance_types_custom ElastigroupGke#instance_types_custom}
    */
    readonly instanceTypesCustom?: ElastigroupGkeInstanceTypesCustom[] | cdktf.IResolvable;
    /**
    * integration_docker_swarm block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#integration_docker_swarm ElastigroupGke#integration_docker_swarm}
    */
    readonly integrationDockerSwarm?: ElastigroupGkeIntegrationDockerSwarm;
    /**
    * integration_gke block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#integration_gke ElastigroupGke#integration_gke}
    */
    readonly integrationGke?: ElastigroupGkeIntegrationGke;
    /**
    * labels block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#labels ElastigroupGke#labels}
    */
    readonly labels?: ElastigroupGkeLabels[] | cdktf.IResolvable;
    /**
    * metadata block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#metadata ElastigroupGke#metadata}
    */
    readonly metadata?: ElastigroupGkeMetadata[] | cdktf.IResolvable;
    /**
    * network_interface block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#network_interface ElastigroupGke#network_interface}
    */
    readonly networkInterface?: ElastigroupGkeNetworkInterface[] | cdktf.IResolvable;
    /**
    * revert_to_preemptible block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#revert_to_preemptible ElastigroupGke#revert_to_preemptible}
    */
    readonly revertToPreemptible?: ElastigroupGkeRevertToPreemptible[] | cdktf.IResolvable;
    /**
    * scaling_down_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#scaling_down_policy ElastigroupGke#scaling_down_policy}
    */
    readonly scalingDownPolicy?: ElastigroupGkeScalingDownPolicy[] | cdktf.IResolvable;
    /**
    * scaling_up_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#scaling_up_policy ElastigroupGke#scaling_up_policy}
    */
    readonly scalingUpPolicy?: ElastigroupGkeScalingUpPolicy[] | cdktf.IResolvable;
    /**
    * shielded_instance_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#shielded_instance_config ElastigroupGke#shielded_instance_config}
    */
    readonly shieldedInstanceConfig?: ElastigroupGkeShieldedInstanceConfig;
}
export interface ElastigroupGkeBackendServicesNamedPorts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#name ElastigroupGke#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#ports ElastigroupGke#ports}
    */
    readonly ports: string[];
}
export declare function elastigroupGkeBackendServicesNamedPortsToTerraform(struct?: ElastigroupGkeBackendServicesNamedPorts | cdktf.IResolvable): any;
export declare function elastigroupGkeBackendServicesNamedPortsToHclTerraform(struct?: ElastigroupGkeBackendServicesNamedPorts | cdktf.IResolvable): any;
export declare class ElastigroupGkeBackendServicesNamedPortsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeBackendServicesNamedPorts | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeBackendServicesNamedPorts | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _ports?;
    get ports(): string[];
    set ports(value: string[]);
    get portsInput(): string[] | undefined;
}
export declare class ElastigroupGkeBackendServicesNamedPortsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeBackendServicesNamedPorts[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeBackendServicesNamedPortsOutputReference;
}
export interface ElastigroupGkeBackendServices {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#location_type ElastigroupGke#location_type}
    */
    readonly locationType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#scheme ElastigroupGke#scheme}
    */
    readonly scheme?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#service_name ElastigroupGke#service_name}
    */
    readonly serviceName: string;
    /**
    * named_ports block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#named_ports ElastigroupGke#named_ports}
    */
    readonly namedPorts?: ElastigroupGkeBackendServicesNamedPorts[] | cdktf.IResolvable;
}
export declare function elastigroupGkeBackendServicesToTerraform(struct?: ElastigroupGkeBackendServices | cdktf.IResolvable): any;
export declare function elastigroupGkeBackendServicesToHclTerraform(struct?: ElastigroupGkeBackendServices | cdktf.IResolvable): any;
export declare class ElastigroupGkeBackendServicesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeBackendServices | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeBackendServices | cdktf.IResolvable | undefined);
    private _locationType?;
    get locationType(): string;
    set locationType(value: string);
    resetLocationType(): void;
    get locationTypeInput(): string | undefined;
    private _scheme?;
    get scheme(): string;
    set scheme(value: string);
    resetScheme(): void;
    get schemeInput(): string | undefined;
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    get serviceNameInput(): string | undefined;
    private _namedPorts;
    get namedPorts(): ElastigroupGkeBackendServicesNamedPortsList;
    putNamedPorts(value: ElastigroupGkeBackendServicesNamedPorts[] | cdktf.IResolvable): void;
    resetNamedPorts(): void;
    get namedPortsInput(): cdktf.IResolvable | ElastigroupGkeBackendServicesNamedPorts[] | undefined;
}
export declare class ElastigroupGkeBackendServicesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeBackendServices[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeBackendServicesOutputReference;
}
export interface ElastigroupGkeDiskInitializeParams {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#disk_size_gb ElastigroupGke#disk_size_gb}
    */
    readonly diskSizeGb?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#disk_type ElastigroupGke#disk_type}
    */
    readonly diskType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#source_image ElastigroupGke#source_image}
    */
    readonly sourceImage: string;
}
export declare function elastigroupGkeDiskInitializeParamsToTerraform(struct?: ElastigroupGkeDiskInitializeParams | cdktf.IResolvable): any;
export declare function elastigroupGkeDiskInitializeParamsToHclTerraform(struct?: ElastigroupGkeDiskInitializeParams | cdktf.IResolvable): any;
export declare class ElastigroupGkeDiskInitializeParamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeDiskInitializeParams | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeDiskInitializeParams | cdktf.IResolvable | undefined);
    private _diskSizeGb?;
    get diskSizeGb(): string;
    set diskSizeGb(value: string);
    resetDiskSizeGb(): void;
    get diskSizeGbInput(): string | undefined;
    private _diskType?;
    get diskType(): string;
    set diskType(value: string);
    resetDiskType(): void;
    get diskTypeInput(): string | undefined;
    private _sourceImage?;
    get sourceImage(): string;
    set sourceImage(value: string);
    get sourceImageInput(): string | undefined;
}
export declare class ElastigroupGkeDiskInitializeParamsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeDiskInitializeParams[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeDiskInitializeParamsOutputReference;
}
export interface ElastigroupGkeDisk {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#auto_delete ElastigroupGke#auto_delete}
    */
    readonly autoDelete?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#boot ElastigroupGke#boot}
    */
    readonly boot?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#device_name ElastigroupGke#device_name}
    */
    readonly deviceName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#interface ElastigroupGke#interface}
    */
    readonly interface?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#mode ElastigroupGke#mode}
    */
    readonly mode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#source ElastigroupGke#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#type ElastigroupGke#type}
    */
    readonly type?: string;
    /**
    * initialize_params block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#initialize_params ElastigroupGke#initialize_params}
    */
    readonly initializeParams?: ElastigroupGkeDiskInitializeParams[] | cdktf.IResolvable;
}
export declare function elastigroupGkeDiskToTerraform(struct?: ElastigroupGkeDisk | cdktf.IResolvable): any;
export declare function elastigroupGkeDiskToHclTerraform(struct?: ElastigroupGkeDisk | cdktf.IResolvable): any;
export declare class ElastigroupGkeDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeDisk | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeDisk | cdktf.IResolvable | undefined);
    private _autoDelete?;
    get autoDelete(): boolean | cdktf.IResolvable;
    set autoDelete(value: boolean | cdktf.IResolvable);
    resetAutoDelete(): void;
    get autoDeleteInput(): boolean | cdktf.IResolvable | undefined;
    private _boot?;
    get boot(): boolean | cdktf.IResolvable;
    set boot(value: boolean | cdktf.IResolvable);
    resetBoot(): void;
    get bootInput(): boolean | cdktf.IResolvable | undefined;
    private _deviceName?;
    get deviceName(): string;
    set deviceName(value: string);
    resetDeviceName(): void;
    get deviceNameInput(): string | undefined;
    private _interface?;
    get interface(): string;
    set interface(value: string);
    resetInterface(): void;
    get interfaceInput(): string | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    resetSource(): void;
    get sourceInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _initializeParams;
    get initializeParams(): ElastigroupGkeDiskInitializeParamsList;
    putInitializeParams(value: ElastigroupGkeDiskInitializeParams[] | cdktf.IResolvable): void;
    resetInitializeParams(): void;
    get initializeParamsInput(): cdktf.IResolvable | ElastigroupGkeDiskInitializeParams[] | undefined;
}
export declare class ElastigroupGkeDiskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeDisk[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeDiskOutputReference;
}
export interface ElastigroupGkeGpu {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#count ElastigroupGke#count}
    */
    readonly count: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#type ElastigroupGke#type}
    */
    readonly type: string;
}
export declare function elastigroupGkeGpuToTerraform(struct?: ElastigroupGkeGpu | cdktf.IResolvable): any;
export declare function elastigroupGkeGpuToHclTerraform(struct?: ElastigroupGkeGpu | cdktf.IResolvable): any;
export declare class ElastigroupGkeGpuOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeGpu | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeGpu | cdktf.IResolvable | undefined);
    private _count?;
    get count(): number;
    set count(value: number);
    get countInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class ElastigroupGkeGpuList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeGpu[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeGpuOutputReference;
}
export interface ElastigroupGkeInstanceTypesCustom {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#memory_gib ElastigroupGke#memory_gib}
    */
    readonly memoryGib: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#vcpu ElastigroupGke#vcpu}
    */
    readonly vcpu: number;
}
export declare function elastigroupGkeInstanceTypesCustomToTerraform(struct?: ElastigroupGkeInstanceTypesCustom | cdktf.IResolvable): any;
export declare function elastigroupGkeInstanceTypesCustomToHclTerraform(struct?: ElastigroupGkeInstanceTypesCustom | cdktf.IResolvable): any;
export declare class ElastigroupGkeInstanceTypesCustomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeInstanceTypesCustom | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeInstanceTypesCustom | cdktf.IResolvable | undefined);
    private _memoryGib?;
    get memoryGib(): number;
    set memoryGib(value: number);
    get memoryGibInput(): number | undefined;
    private _vcpu?;
    get vcpu(): number;
    set vcpu(value: number);
    get vcpuInput(): number | undefined;
}
export declare class ElastigroupGkeInstanceTypesCustomList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeInstanceTypesCustom[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeInstanceTypesCustomOutputReference;
}
export interface ElastigroupGkeIntegrationDockerSwarm {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#master_host ElastigroupGke#master_host}
    */
    readonly masterHost: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#master_port ElastigroupGke#master_port}
    */
    readonly masterPort: number;
}
export declare function elastigroupGkeIntegrationDockerSwarmToTerraform(struct?: ElastigroupGkeIntegrationDockerSwarmOutputReference | ElastigroupGkeIntegrationDockerSwarm): any;
export declare function elastigroupGkeIntegrationDockerSwarmToHclTerraform(struct?: ElastigroupGkeIntegrationDockerSwarmOutputReference | ElastigroupGkeIntegrationDockerSwarm): any;
export declare class ElastigroupGkeIntegrationDockerSwarmOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupGkeIntegrationDockerSwarm | undefined;
    set internalValue(value: ElastigroupGkeIntegrationDockerSwarm | undefined);
    private _masterHost?;
    get masterHost(): string;
    set masterHost(value: string);
    get masterHostInput(): string | undefined;
    private _masterPort?;
    get masterPort(): number;
    set masterPort(value: number);
    get masterPortInput(): number | undefined;
}
export interface ElastigroupGkeIntegrationGkeAutoscaleDown {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#evaluation_periods ElastigroupGke#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
}
export declare function elastigroupGkeIntegrationGkeAutoscaleDownToTerraform(struct?: ElastigroupGkeIntegrationGkeAutoscaleDownOutputReference | ElastigroupGkeIntegrationGkeAutoscaleDown): any;
export declare function elastigroupGkeIntegrationGkeAutoscaleDownToHclTerraform(struct?: ElastigroupGkeIntegrationGkeAutoscaleDownOutputReference | ElastigroupGkeIntegrationGkeAutoscaleDown): any;
export declare class ElastigroupGkeIntegrationGkeAutoscaleDownOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupGkeIntegrationGkeAutoscaleDown | undefined;
    set internalValue(value: ElastigroupGkeIntegrationGkeAutoscaleDown | undefined);
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
}
export interface ElastigroupGkeIntegrationGkeAutoscaleHeadroom {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#cpu_per_unit ElastigroupGke#cpu_per_unit}
    */
    readonly cpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#memory_per_unit ElastigroupGke#memory_per_unit}
    */
    readonly memoryPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#num_of_units ElastigroupGke#num_of_units}
    */
    readonly numOfUnits?: number;
}
export declare function elastigroupGkeIntegrationGkeAutoscaleHeadroomToTerraform(struct?: ElastigroupGkeIntegrationGkeAutoscaleHeadroomOutputReference | ElastigroupGkeIntegrationGkeAutoscaleHeadroom): any;
export declare function elastigroupGkeIntegrationGkeAutoscaleHeadroomToHclTerraform(struct?: ElastigroupGkeIntegrationGkeAutoscaleHeadroomOutputReference | ElastigroupGkeIntegrationGkeAutoscaleHeadroom): any;
export declare class ElastigroupGkeIntegrationGkeAutoscaleHeadroomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupGkeIntegrationGkeAutoscaleHeadroom | undefined;
    set internalValue(value: ElastigroupGkeIntegrationGkeAutoscaleHeadroom | undefined);
    private _cpuPerUnit?;
    get cpuPerUnit(): number;
    set cpuPerUnit(value: number);
    resetCpuPerUnit(): void;
    get cpuPerUnitInput(): number | undefined;
    private _memoryPerUnit?;
    get memoryPerUnit(): number;
    set memoryPerUnit(value: number);
    resetMemoryPerUnit(): void;
    get memoryPerUnitInput(): number | undefined;
    private _numOfUnits?;
    get numOfUnits(): number;
    set numOfUnits(value: number);
    resetNumOfUnits(): void;
    get numOfUnitsInput(): number | undefined;
}
export interface ElastigroupGkeIntegrationGkeAutoscaleLabels {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#key ElastigroupGke#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#value ElastigroupGke#value}
    */
    readonly value: string;
}
export declare function elastigroupGkeIntegrationGkeAutoscaleLabelsToTerraform(struct?: ElastigroupGkeIntegrationGkeAutoscaleLabels | cdktf.IResolvable): any;
export declare function elastigroupGkeIntegrationGkeAutoscaleLabelsToHclTerraform(struct?: ElastigroupGkeIntegrationGkeAutoscaleLabels | cdktf.IResolvable): any;
export declare class ElastigroupGkeIntegrationGkeAutoscaleLabelsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeIntegrationGkeAutoscaleLabels | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeIntegrationGkeAutoscaleLabels | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class ElastigroupGkeIntegrationGkeAutoscaleLabelsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeIntegrationGkeAutoscaleLabels[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeIntegrationGkeAutoscaleLabelsOutputReference;
}
export interface ElastigroupGkeIntegrationGke {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#auto_update ElastigroupGke#auto_update}
    */
    readonly autoUpdate?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#autoscale_cooldown ElastigroupGke#autoscale_cooldown}
    */
    readonly autoscaleCooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#autoscale_is_auto_config ElastigroupGke#autoscale_is_auto_config}
    */
    readonly autoscaleIsAutoConfig?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#autoscale_is_enabled ElastigroupGke#autoscale_is_enabled}
    */
    readonly autoscaleIsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#cluster_id ElastigroupGke#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#location ElastigroupGke#location}
    */
    readonly location?: string;
    /**
    * autoscale_down block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#autoscale_down ElastigroupGke#autoscale_down}
    */
    readonly autoscaleDown?: ElastigroupGkeIntegrationGkeAutoscaleDown;
    /**
    * autoscale_headroom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#autoscale_headroom ElastigroupGke#autoscale_headroom}
    */
    readonly autoscaleHeadroom?: ElastigroupGkeIntegrationGkeAutoscaleHeadroom;
    /**
    * autoscale_labels block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#autoscale_labels ElastigroupGke#autoscale_labels}
    */
    readonly autoscaleLabels?: ElastigroupGkeIntegrationGkeAutoscaleLabels[] | cdktf.IResolvable;
}
export declare function elastigroupGkeIntegrationGkeToTerraform(struct?: ElastigroupGkeIntegrationGkeOutputReference | ElastigroupGkeIntegrationGke): any;
export declare function elastigroupGkeIntegrationGkeToHclTerraform(struct?: ElastigroupGkeIntegrationGkeOutputReference | ElastigroupGkeIntegrationGke): any;
export declare class ElastigroupGkeIntegrationGkeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupGkeIntegrationGke | undefined;
    set internalValue(value: ElastigroupGkeIntegrationGke | undefined);
    private _autoUpdate?;
    get autoUpdate(): boolean | cdktf.IResolvable;
    set autoUpdate(value: boolean | cdktf.IResolvable);
    resetAutoUpdate(): void;
    get autoUpdateInput(): boolean | cdktf.IResolvable | undefined;
    private _autoscaleCooldown?;
    get autoscaleCooldown(): number;
    set autoscaleCooldown(value: number);
    resetAutoscaleCooldown(): void;
    get autoscaleCooldownInput(): number | undefined;
    private _autoscaleIsAutoConfig?;
    get autoscaleIsAutoConfig(): boolean | cdktf.IResolvable;
    set autoscaleIsAutoConfig(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsAutoConfig(): void;
    get autoscaleIsAutoConfigInput(): boolean | cdktf.IResolvable | undefined;
    private _autoscaleIsEnabled?;
    get autoscaleIsEnabled(): boolean | cdktf.IResolvable;
    set autoscaleIsEnabled(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsEnabled(): void;
    get autoscaleIsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _autoscaleDown;
    get autoscaleDown(): ElastigroupGkeIntegrationGkeAutoscaleDownOutputReference;
    putAutoscaleDown(value: ElastigroupGkeIntegrationGkeAutoscaleDown): void;
    resetAutoscaleDown(): void;
    get autoscaleDownInput(): ElastigroupGkeIntegrationGkeAutoscaleDown | undefined;
    private _autoscaleHeadroom;
    get autoscaleHeadroom(): ElastigroupGkeIntegrationGkeAutoscaleHeadroomOutputReference;
    putAutoscaleHeadroom(value: ElastigroupGkeIntegrationGkeAutoscaleHeadroom): void;
    resetAutoscaleHeadroom(): void;
    get autoscaleHeadroomInput(): ElastigroupGkeIntegrationGkeAutoscaleHeadroom | undefined;
    private _autoscaleLabels;
    get autoscaleLabels(): ElastigroupGkeIntegrationGkeAutoscaleLabelsList;
    putAutoscaleLabels(value: ElastigroupGkeIntegrationGkeAutoscaleLabels[] | cdktf.IResolvable): void;
    resetAutoscaleLabels(): void;
    get autoscaleLabelsInput(): cdktf.IResolvable | ElastigroupGkeIntegrationGkeAutoscaleLabels[] | undefined;
}
export interface ElastigroupGkeLabels {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#key ElastigroupGke#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#value ElastigroupGke#value}
    */
    readonly value: string;
}
export declare function elastigroupGkeLabelsToTerraform(struct?: ElastigroupGkeLabels | cdktf.IResolvable): any;
export declare function elastigroupGkeLabelsToHclTerraform(struct?: ElastigroupGkeLabels | cdktf.IResolvable): any;
export declare class ElastigroupGkeLabelsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeLabels | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeLabels | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class ElastigroupGkeLabelsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeLabels[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeLabelsOutputReference;
}
export interface ElastigroupGkeMetadata {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#key ElastigroupGke#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#value ElastigroupGke#value}
    */
    readonly value: string;
}
export declare function elastigroupGkeMetadataToTerraform(struct?: ElastigroupGkeMetadata | cdktf.IResolvable): any;
export declare function elastigroupGkeMetadataToHclTerraform(struct?: ElastigroupGkeMetadata | cdktf.IResolvable): any;
export declare class ElastigroupGkeMetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeMetadata | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeMetadata | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class ElastigroupGkeMetadataList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeMetadata[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeMetadataOutputReference;
}
export interface ElastigroupGkeNetworkInterfaceAccessConfigs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#name ElastigroupGke#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#type ElastigroupGke#type}
    */
    readonly type?: string;
}
export declare function elastigroupGkeNetworkInterfaceAccessConfigsToTerraform(struct?: ElastigroupGkeNetworkInterfaceAccessConfigs | cdktf.IResolvable): any;
export declare function elastigroupGkeNetworkInterfaceAccessConfigsToHclTerraform(struct?: ElastigroupGkeNetworkInterfaceAccessConfigs | cdktf.IResolvable): any;
export declare class ElastigroupGkeNetworkInterfaceAccessConfigsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeNetworkInterfaceAccessConfigs | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeNetworkInterfaceAccessConfigs | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export declare class ElastigroupGkeNetworkInterfaceAccessConfigsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeNetworkInterfaceAccessConfigs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeNetworkInterfaceAccessConfigsOutputReference;
}
export interface ElastigroupGkeNetworkInterfaceAliasIpRanges {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#ip_cidr_range ElastigroupGke#ip_cidr_range}
    */
    readonly ipCidrRange: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#subnetwork_range_name ElastigroupGke#subnetwork_range_name}
    */
    readonly subnetworkRangeName: string;
}
export declare function elastigroupGkeNetworkInterfaceAliasIpRangesToTerraform(struct?: ElastigroupGkeNetworkInterfaceAliasIpRanges | cdktf.IResolvable): any;
export declare function elastigroupGkeNetworkInterfaceAliasIpRangesToHclTerraform(struct?: ElastigroupGkeNetworkInterfaceAliasIpRanges | cdktf.IResolvable): any;
export declare class ElastigroupGkeNetworkInterfaceAliasIpRangesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeNetworkInterfaceAliasIpRanges | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeNetworkInterfaceAliasIpRanges | cdktf.IResolvable | undefined);
    private _ipCidrRange?;
    get ipCidrRange(): string;
    set ipCidrRange(value: string);
    get ipCidrRangeInput(): string | undefined;
    private _subnetworkRangeName?;
    get subnetworkRangeName(): string;
    set subnetworkRangeName(value: string);
    get subnetworkRangeNameInput(): string | undefined;
}
export declare class ElastigroupGkeNetworkInterfaceAliasIpRangesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeNetworkInterfaceAliasIpRanges[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeNetworkInterfaceAliasIpRangesOutputReference;
}
export interface ElastigroupGkeNetworkInterface {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#network ElastigroupGke#network}
    */
    readonly network: string;
    /**
    * access_configs block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#access_configs ElastigroupGke#access_configs}
    */
    readonly accessConfigs?: ElastigroupGkeNetworkInterfaceAccessConfigs[] | cdktf.IResolvable;
    /**
    * alias_ip_ranges block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#alias_ip_ranges ElastigroupGke#alias_ip_ranges}
    */
    readonly aliasIpRanges?: ElastigroupGkeNetworkInterfaceAliasIpRanges[] | cdktf.IResolvable;
}
export declare function elastigroupGkeNetworkInterfaceToTerraform(struct?: ElastigroupGkeNetworkInterface | cdktf.IResolvable): any;
export declare function elastigroupGkeNetworkInterfaceToHclTerraform(struct?: ElastigroupGkeNetworkInterface | cdktf.IResolvable): any;
export declare class ElastigroupGkeNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeNetworkInterface | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeNetworkInterface | cdktf.IResolvable | undefined);
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
    private _accessConfigs;
    get accessConfigs(): ElastigroupGkeNetworkInterfaceAccessConfigsList;
    putAccessConfigs(value: ElastigroupGkeNetworkInterfaceAccessConfigs[] | cdktf.IResolvable): void;
    resetAccessConfigs(): void;
    get accessConfigsInput(): cdktf.IResolvable | ElastigroupGkeNetworkInterfaceAccessConfigs[] | undefined;
    private _aliasIpRanges;
    get aliasIpRanges(): ElastigroupGkeNetworkInterfaceAliasIpRangesList;
    putAliasIpRanges(value: ElastigroupGkeNetworkInterfaceAliasIpRanges[] | cdktf.IResolvable): void;
    resetAliasIpRanges(): void;
    get aliasIpRangesInput(): cdktf.IResolvable | ElastigroupGkeNetworkInterfaceAliasIpRanges[] | undefined;
}
export declare class ElastigroupGkeNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeNetworkInterface[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeNetworkInterfaceOutputReference;
}
export interface ElastigroupGkeRevertToPreemptible {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#perform_at ElastigroupGke#perform_at}
    */
    readonly performAt: string;
}
export declare function elastigroupGkeRevertToPreemptibleToTerraform(struct?: ElastigroupGkeRevertToPreemptible | cdktf.IResolvable): any;
export declare function elastigroupGkeRevertToPreemptibleToHclTerraform(struct?: ElastigroupGkeRevertToPreemptible | cdktf.IResolvable): any;
export declare class ElastigroupGkeRevertToPreemptibleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeRevertToPreemptible | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeRevertToPreemptible | cdktf.IResolvable | undefined);
    private _performAt?;
    get performAt(): string;
    set performAt(value: string);
    get performAtInput(): string | undefined;
}
export declare class ElastigroupGkeRevertToPreemptibleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeRevertToPreemptible[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeRevertToPreemptibleOutputReference;
}
export interface ElastigroupGkeScalingDownPolicyDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#name ElastigroupGke#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#value ElastigroupGke#value}
    */
    readonly value?: string;
}
export declare function elastigroupGkeScalingDownPolicyDimensionsToTerraform(struct?: ElastigroupGkeScalingDownPolicyDimensions | cdktf.IResolvable): any;
export declare function elastigroupGkeScalingDownPolicyDimensionsToHclTerraform(struct?: ElastigroupGkeScalingDownPolicyDimensions | cdktf.IResolvable): any;
export declare class ElastigroupGkeScalingDownPolicyDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeScalingDownPolicyDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeScalingDownPolicyDimensions | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupGkeScalingDownPolicyDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeScalingDownPolicyDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeScalingDownPolicyDimensionsOutputReference;
}
export interface ElastigroupGkeScalingDownPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#action_type ElastigroupGke#action_type}
    */
    readonly actionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#adjustment ElastigroupGke#adjustment}
    */
    readonly adjustment?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#cooldown ElastigroupGke#cooldown}
    */
    readonly cooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#evaluation_periods ElastigroupGke#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#metric_name ElastigroupGke#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#namespace ElastigroupGke#namespace}
    */
    readonly namespace: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#operator ElastigroupGke#operator}
    */
    readonly operator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#period ElastigroupGke#period}
    */
    readonly period?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#policy_name ElastigroupGke#policy_name}
    */
    readonly policyName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#source ElastigroupGke#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#statistic ElastigroupGke#statistic}
    */
    readonly statistic?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#threshold ElastigroupGke#threshold}
    */
    readonly threshold: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#unit ElastigroupGke#unit}
    */
    readonly unit: string;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#dimensions ElastigroupGke#dimensions}
    */
    readonly dimensions?: ElastigroupGkeScalingDownPolicyDimensions[] | cdktf.IResolvable;
}
export declare function elastigroupGkeScalingDownPolicyToTerraform(struct?: ElastigroupGkeScalingDownPolicy | cdktf.IResolvable): any;
export declare function elastigroupGkeScalingDownPolicyToHclTerraform(struct?: ElastigroupGkeScalingDownPolicy | cdktf.IResolvable): any;
export declare class ElastigroupGkeScalingDownPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeScalingDownPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeScalingDownPolicy | cdktf.IResolvable | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    resetActionType(): void;
    get actionTypeInput(): string | undefined;
    private _adjustment?;
    get adjustment(): number;
    set adjustment(value: number);
    resetAdjustment(): void;
    get adjustmentInput(): number | undefined;
    private _cooldown?;
    get cooldown(): number;
    set cooldown(value: number);
    resetCooldown(): void;
    get cooldownInput(): number | undefined;
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    get namespaceInput(): string | undefined;
    private _operator?;
    get operator(): string;
    set operator(value: string);
    resetOperator(): void;
    get operatorInput(): string | undefined;
    private _period?;
    get period(): number;
    set period(value: number);
    resetPeriod(): void;
    get periodInput(): number | undefined;
    private _policyName?;
    get policyName(): string;
    set policyName(value: string);
    get policyNameInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    resetSource(): void;
    get sourceInput(): string | undefined;
    private _statistic?;
    get statistic(): string;
    set statistic(value: string);
    resetStatistic(): void;
    get statisticInput(): string | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    get thresholdInput(): number | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    get unitInput(): string | undefined;
    private _dimensions;
    get dimensions(): ElastigroupGkeScalingDownPolicyDimensionsList;
    putDimensions(value: ElastigroupGkeScalingDownPolicyDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | ElastigroupGkeScalingDownPolicyDimensions[] | undefined;
}
export declare class ElastigroupGkeScalingDownPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeScalingDownPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeScalingDownPolicyOutputReference;
}
export interface ElastigroupGkeScalingUpPolicyDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#name ElastigroupGke#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#value ElastigroupGke#value}
    */
    readonly value?: string;
}
export declare function elastigroupGkeScalingUpPolicyDimensionsToTerraform(struct?: ElastigroupGkeScalingUpPolicyDimensions | cdktf.IResolvable): any;
export declare function elastigroupGkeScalingUpPolicyDimensionsToHclTerraform(struct?: ElastigroupGkeScalingUpPolicyDimensions | cdktf.IResolvable): any;
export declare class ElastigroupGkeScalingUpPolicyDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeScalingUpPolicyDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeScalingUpPolicyDimensions | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupGkeScalingUpPolicyDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeScalingUpPolicyDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeScalingUpPolicyDimensionsOutputReference;
}
export interface ElastigroupGkeScalingUpPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#action_type ElastigroupGke#action_type}
    */
    readonly actionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#adjustment ElastigroupGke#adjustment}
    */
    readonly adjustment?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#cooldown ElastigroupGke#cooldown}
    */
    readonly cooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#evaluation_periods ElastigroupGke#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#metric_name ElastigroupGke#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#namespace ElastigroupGke#namespace}
    */
    readonly namespace: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#operator ElastigroupGke#operator}
    */
    readonly operator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#period ElastigroupGke#period}
    */
    readonly period?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#policy_name ElastigroupGke#policy_name}
    */
    readonly policyName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#source ElastigroupGke#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#statistic ElastigroupGke#statistic}
    */
    readonly statistic?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#threshold ElastigroupGke#threshold}
    */
    readonly threshold: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#unit ElastigroupGke#unit}
    */
    readonly unit: string;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#dimensions ElastigroupGke#dimensions}
    */
    readonly dimensions?: ElastigroupGkeScalingUpPolicyDimensions[] | cdktf.IResolvable;
}
export declare function elastigroupGkeScalingUpPolicyToTerraform(struct?: ElastigroupGkeScalingUpPolicy | cdktf.IResolvable): any;
export declare function elastigroupGkeScalingUpPolicyToHclTerraform(struct?: ElastigroupGkeScalingUpPolicy | cdktf.IResolvable): any;
export declare class ElastigroupGkeScalingUpPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupGkeScalingUpPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupGkeScalingUpPolicy | cdktf.IResolvable | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    resetActionType(): void;
    get actionTypeInput(): string | undefined;
    private _adjustment?;
    get adjustment(): number;
    set adjustment(value: number);
    resetAdjustment(): void;
    get adjustmentInput(): number | undefined;
    private _cooldown?;
    get cooldown(): number;
    set cooldown(value: number);
    resetCooldown(): void;
    get cooldownInput(): number | undefined;
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    get namespaceInput(): string | undefined;
    private _operator?;
    get operator(): string;
    set operator(value: string);
    resetOperator(): void;
    get operatorInput(): string | undefined;
    private _period?;
    get period(): number;
    set period(value: number);
    resetPeriod(): void;
    get periodInput(): number | undefined;
    private _policyName?;
    get policyName(): string;
    set policyName(value: string);
    get policyNameInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    resetSource(): void;
    get sourceInput(): string | undefined;
    private _statistic?;
    get statistic(): string;
    set statistic(value: string);
    resetStatistic(): void;
    get statisticInput(): string | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    get thresholdInput(): number | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    get unitInput(): string | undefined;
    private _dimensions;
    get dimensions(): ElastigroupGkeScalingUpPolicyDimensionsList;
    putDimensions(value: ElastigroupGkeScalingUpPolicyDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | ElastigroupGkeScalingUpPolicyDimensions[] | undefined;
}
export declare class ElastigroupGkeScalingUpPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupGkeScalingUpPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupGkeScalingUpPolicyOutputReference;
}
export interface ElastigroupGkeShieldedInstanceConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#enable_integrity_monitoring ElastigroupGke#enable_integrity_monitoring}
    */
    readonly enableIntegrityMonitoring?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#enable_secure_boot ElastigroupGke#enable_secure_boot}
    */
    readonly enableSecureBoot?: boolean | cdktf.IResolvable;
}
export declare function elastigroupGkeShieldedInstanceConfigToTerraform(struct?: ElastigroupGkeShieldedInstanceConfigOutputReference | ElastigroupGkeShieldedInstanceConfig): any;
export declare function elastigroupGkeShieldedInstanceConfigToHclTerraform(struct?: ElastigroupGkeShieldedInstanceConfigOutputReference | ElastigroupGkeShieldedInstanceConfig): any;
export declare class ElastigroupGkeShieldedInstanceConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupGkeShieldedInstanceConfig | undefined;
    set internalValue(value: ElastigroupGkeShieldedInstanceConfig | undefined);
    private _enableIntegrityMonitoring?;
    get enableIntegrityMonitoring(): boolean | cdktf.IResolvable;
    set enableIntegrityMonitoring(value: boolean | cdktf.IResolvable);
    resetEnableIntegrityMonitoring(): void;
    get enableIntegrityMonitoringInput(): boolean | cdktf.IResolvable | undefined;
    private _enableSecureBoot?;
    get enableSecureBoot(): boolean | cdktf.IResolvable;
    set enableSecureBoot(value: boolean | cdktf.IResolvable);
    resetEnableSecureBoot(): void;
    get enableSecureBootInput(): boolean | cdktf.IResolvable | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke spotinst_elastigroup_gke}
*/
export declare class ElastigroupGke extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_elastigroup_gke";
    /**
    * Generates CDKTF code for importing a ElastigroupGke resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ElastigroupGke to import
    * @param importFromId The id of the existing ElastigroupGke that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ElastigroupGke to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/elastigroup_gke spotinst_elastigroup_gke} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ElastigroupGkeConfig
    */
    constructor(scope: Construct, id: string, config: ElastigroupGkeConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    private _clusterZoneName?;
    get clusterZoneName(): string;
    set clusterZoneName(value: string);
    get clusterZoneNameInput(): string | undefined;
    private _desiredCapacity?;
    get desiredCapacity(): number;
    set desiredCapacity(value: number);
    get desiredCapacityInput(): number | undefined;
    private _drainingTimeout?;
    get drainingTimeout(): number;
    set drainingTimeout(value: number);
    resetDrainingTimeout(): void;
    get drainingTimeoutInput(): number | undefined;
    private _fallbackToOndemand?;
    get fallbackToOndemand(): boolean | cdktf.IResolvable;
    set fallbackToOndemand(value: boolean | cdktf.IResolvable);
    resetFallbackToOndemand(): void;
    get fallbackToOndemandInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _instanceNamePrefix?;
    get instanceNamePrefix(): string;
    set instanceNamePrefix(value: string);
    resetInstanceNamePrefix(): void;
    get instanceNamePrefixInput(): string | undefined;
    private _instanceTypesOndemand?;
    get instanceTypesOndemand(): string;
    set instanceTypesOndemand(value: string);
    resetInstanceTypesOndemand(): void;
    get instanceTypesOndemandInput(): string | undefined;
    private _instanceTypesPreemptible?;
    get instanceTypesPreemptible(): string[];
    set instanceTypesPreemptible(value: string[]);
    resetInstanceTypesPreemptible(): void;
    get instanceTypesPreemptibleInput(): string[] | undefined;
    private _ipForwarding?;
    get ipForwarding(): boolean | cdktf.IResolvable;
    set ipForwarding(value: boolean | cdktf.IResolvable);
    resetIpForwarding(): void;
    get ipForwardingInput(): boolean | cdktf.IResolvable | undefined;
    private _maxSize?;
    get maxSize(): number;
    set maxSize(value: number);
    resetMaxSize(): void;
    get maxSizeInput(): number | undefined;
    private _minCpuPlatform?;
    get minCpuPlatform(): string;
    set minCpuPlatform(value: string);
    resetMinCpuPlatform(): void;
    get minCpuPlatformInput(): string | undefined;
    private _minSize?;
    get minSize(): number;
    set minSize(value: number);
    resetMinSize(): void;
    get minSizeInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _nodeImage?;
    get nodeImage(): string;
    set nodeImage(value: string);
    resetNodeImage(): void;
    get nodeImageInput(): string | undefined;
    private _ondemandCount?;
    get ondemandCount(): number;
    set ondemandCount(value: number);
    resetOndemandCount(): void;
    get ondemandCountInput(): number | undefined;
    private _optimizationWindows?;
    get optimizationWindows(): string[];
    set optimizationWindows(value: string[]);
    resetOptimizationWindows(): void;
    get optimizationWindowsInput(): string[] | undefined;
    private _preemptiblePercentage?;
    get preemptiblePercentage(): number;
    set preemptiblePercentage(value: number);
    resetPreemptiblePercentage(): void;
    get preemptiblePercentageInput(): number | undefined;
    private _provisioningModel?;
    get provisioningModel(): string;
    set provisioningModel(value: string);
    resetProvisioningModel(): void;
    get provisioningModelInput(): string | undefined;
    private _serviceAccount?;
    get serviceAccount(): string;
    set serviceAccount(value: string);
    resetServiceAccount(): void;
    get serviceAccountInput(): string | undefined;
    private _shouldUtilizeCommitments?;
    get shouldUtilizeCommitments(): boolean | cdktf.IResolvable;
    set shouldUtilizeCommitments(value: boolean | cdktf.IResolvable);
    resetShouldUtilizeCommitments(): void;
    get shouldUtilizeCommitmentsInput(): boolean | cdktf.IResolvable | undefined;
    private _shutdownScript?;
    get shutdownScript(): string;
    set shutdownScript(value: string);
    resetShutdownScript(): void;
    get shutdownScriptInput(): string | undefined;
    private _startupScript?;
    get startupScript(): string;
    set startupScript(value: string);
    resetStartupScript(): void;
    get startupScriptInput(): string | undefined;
    private _tags?;
    get tags(): string[];
    set tags(value: string[]);
    resetTags(): void;
    get tagsInput(): string[] | undefined;
    private _backendServices;
    get backendServices(): ElastigroupGkeBackendServicesList;
    putBackendServices(value: ElastigroupGkeBackendServices[] | cdktf.IResolvable): void;
    resetBackendServices(): void;
    get backendServicesInput(): cdktf.IResolvable | ElastigroupGkeBackendServices[] | undefined;
    private _disk;
    get disk(): ElastigroupGkeDiskList;
    putDisk(value: ElastigroupGkeDisk[] | cdktf.IResolvable): void;
    resetDisk(): void;
    get diskInput(): cdktf.IResolvable | ElastigroupGkeDisk[] | undefined;
    private _gpu;
    get gpu(): ElastigroupGkeGpuList;
    putGpu(value: ElastigroupGkeGpu[] | cdktf.IResolvable): void;
    resetGpu(): void;
    get gpuInput(): cdktf.IResolvable | ElastigroupGkeGpu[] | undefined;
    private _instanceTypesCustom;
    get instanceTypesCustom(): ElastigroupGkeInstanceTypesCustomList;
    putInstanceTypesCustom(value: ElastigroupGkeInstanceTypesCustom[] | cdktf.IResolvable): void;
    resetInstanceTypesCustom(): void;
    get instanceTypesCustomInput(): cdktf.IResolvable | ElastigroupGkeInstanceTypesCustom[] | undefined;
    private _integrationDockerSwarm;
    get integrationDockerSwarm(): ElastigroupGkeIntegrationDockerSwarmOutputReference;
    putIntegrationDockerSwarm(value: ElastigroupGkeIntegrationDockerSwarm): void;
    resetIntegrationDockerSwarm(): void;
    get integrationDockerSwarmInput(): ElastigroupGkeIntegrationDockerSwarm | undefined;
    private _integrationGke;
    get integrationGke(): ElastigroupGkeIntegrationGkeOutputReference;
    putIntegrationGke(value: ElastigroupGkeIntegrationGke): void;
    resetIntegrationGke(): void;
    get integrationGkeInput(): ElastigroupGkeIntegrationGke | undefined;
    private _labels;
    get labels(): ElastigroupGkeLabelsList;
    putLabels(value: ElastigroupGkeLabels[] | cdktf.IResolvable): void;
    resetLabels(): void;
    get labelsInput(): cdktf.IResolvable | ElastigroupGkeLabels[] | undefined;
    private _metadata;
    get metadata(): ElastigroupGkeMetadataList;
    putMetadata(value: ElastigroupGkeMetadata[] | cdktf.IResolvable): void;
    resetMetadata(): void;
    get metadataInput(): cdktf.IResolvable | ElastigroupGkeMetadata[] | undefined;
    private _networkInterface;
    get networkInterface(): ElastigroupGkeNetworkInterfaceList;
    putNetworkInterface(value: ElastigroupGkeNetworkInterface[] | cdktf.IResolvable): void;
    resetNetworkInterface(): void;
    get networkInterfaceInput(): cdktf.IResolvable | ElastigroupGkeNetworkInterface[] | undefined;
    private _revertToPreemptible;
    get revertToPreemptible(): ElastigroupGkeRevertToPreemptibleList;
    putRevertToPreemptible(value: ElastigroupGkeRevertToPreemptible[] | cdktf.IResolvable): void;
    resetRevertToPreemptible(): void;
    get revertToPreemptibleInput(): cdktf.IResolvable | ElastigroupGkeRevertToPreemptible[] | undefined;
    private _scalingDownPolicy;
    get scalingDownPolicy(): ElastigroupGkeScalingDownPolicyList;
    putScalingDownPolicy(value: ElastigroupGkeScalingDownPolicy[] | cdktf.IResolvable): void;
    resetScalingDownPolicy(): void;
    get scalingDownPolicyInput(): cdktf.IResolvable | ElastigroupGkeScalingDownPolicy[] | undefined;
    private _scalingUpPolicy;
    get scalingUpPolicy(): ElastigroupGkeScalingUpPolicyList;
    putScalingUpPolicy(value: ElastigroupGkeScalingUpPolicy[] | cdktf.IResolvable): void;
    resetScalingUpPolicy(): void;
    get scalingUpPolicyInput(): cdktf.IResolvable | ElastigroupGkeScalingUpPolicy[] | undefined;
    private _shieldedInstanceConfig;
    get shieldedInstanceConfig(): ElastigroupGkeShieldedInstanceConfigOutputReference;
    putShieldedInstanceConfig(value: ElastigroupGkeShieldedInstanceConfig): void;
    resetShieldedInstanceConfig(): void;
    get shieldedInstanceConfigInput(): ElastigroupGkeShieldedInstanceConfig | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
