/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OceanAksNpConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#aks_cluster_name OceanAksNp#aks_cluster_name}
    */
    readonly aksClusterName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#aks_infrastructure_resource_group_name OceanAksNp#aks_infrastructure_resource_group_name}
    */
    readonly aksInfrastructureResourceGroupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#aks_region OceanAksNp#aks_region}
    */
    readonly aksRegion: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#aks_resource_group_name OceanAksNp#aks_resource_group_name}
    */
    readonly aksResourceGroupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#availability_zones OceanAksNp#availability_zones}
    */
    readonly availabilityZones: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#controller_cluster_id OceanAksNp#controller_cluster_id}
    */
    readonly controllerClusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#enable_node_public_ip OceanAksNp#enable_node_public_ip}
    */
    readonly enableNodePublicIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#fallback_to_ondemand OceanAksNp#fallback_to_ondemand}
    */
    readonly fallbackToOndemand?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#id OceanAksNp#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#kubernetes_version OceanAksNp#kubernetes_version}
    */
    readonly kubernetesVersion?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#labels OceanAksNp#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#max_count OceanAksNp#max_count}
    */
    readonly maxCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#max_pods_per_node OceanAksNp#max_pods_per_node}
    */
    readonly maxPodsPerNode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#min_count OceanAksNp#min_count}
    */
    readonly minCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#name OceanAksNp#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#os_disk_size_gb OceanAksNp#os_disk_size_gb}
    */
    readonly osDiskSizeGb?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#os_disk_type OceanAksNp#os_disk_type}
    */
    readonly osDiskType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#os_sku OceanAksNp#os_sku}
    */
    readonly osSku?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#os_type OceanAksNp#os_type}
    */
    readonly osType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#pod_subnet_ids OceanAksNp#pod_subnet_ids}
    */
    readonly podSubnetIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#spot_percentage OceanAksNp#spot_percentage}
    */
    readonly spotPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#tags OceanAksNp#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#vnet_subnet_ids OceanAksNp#vnet_subnet_ids}
    */
    readonly vnetSubnetIds?: string[];
    /**
    * autoscaler block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#autoscaler OceanAksNp#autoscaler}
    */
    readonly autoscaler?: OceanAksNpAutoscaler;
    /**
    * filters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#filters OceanAksNp#filters}
    */
    readonly filters?: OceanAksNpFilters;
    /**
    * headrooms block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#headrooms OceanAksNp#headrooms}
    */
    readonly headrooms?: OceanAksNpHeadrooms[] | cdktf.IResolvable;
    /**
    * health block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#health OceanAksNp#health}
    */
    readonly health?: OceanAksNpHealth;
    /**
    * linux_os_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#linux_os_config OceanAksNp#linux_os_config}
    */
    readonly linuxOsConfig?: OceanAksNpLinuxOsConfig[] | cdktf.IResolvable;
    /**
    * logging block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#logging OceanAksNp#logging}
    */
    readonly logging?: OceanAksNpLogging;
    /**
    * scheduling block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#scheduling OceanAksNp#scheduling}
    */
    readonly scheduling?: OceanAksNpScheduling;
    /**
    * taints block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#taints OceanAksNp#taints}
    */
    readonly taints?: OceanAksNpTaints[] | cdktf.IResolvable;
    /**
    * update_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#update_policy OceanAksNp#update_policy}
    */
    readonly updatePolicy?: OceanAksNpUpdatePolicy;
    /**
    * vng_template_scheduling block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#vng_template_scheduling OceanAksNp#vng_template_scheduling}
    */
    readonly vngTemplateScheduling?: OceanAksNpVngTemplateScheduling;
}
export interface OceanAksNpAutoscalerAutoscaleDown {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#max_scale_down_percentage OceanAksNp#max_scale_down_percentage}
    */
    readonly maxScaleDownPercentage?: number;
}
export declare function oceanAksNpAutoscalerAutoscaleDownToTerraform(struct?: OceanAksNpAutoscalerAutoscaleDownOutputReference | OceanAksNpAutoscalerAutoscaleDown): any;
export declare function oceanAksNpAutoscalerAutoscaleDownToHclTerraform(struct?: OceanAksNpAutoscalerAutoscaleDownOutputReference | OceanAksNpAutoscalerAutoscaleDown): any;
export declare class OceanAksNpAutoscalerAutoscaleDownOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpAutoscalerAutoscaleDown | undefined;
    set internalValue(value: OceanAksNpAutoscalerAutoscaleDown | undefined);
    private _maxScaleDownPercentage?;
    get maxScaleDownPercentage(): number;
    set maxScaleDownPercentage(value: number);
    resetMaxScaleDownPercentage(): void;
    get maxScaleDownPercentageInput(): number | undefined;
}
export interface OceanAksNpAutoscalerAutoscaleHeadroomAutomatic {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#is_enabled OceanAksNp#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#percentage OceanAksNp#percentage}
    */
    readonly percentage?: number;
}
export declare function oceanAksNpAutoscalerAutoscaleHeadroomAutomaticToTerraform(struct?: OceanAksNpAutoscalerAutoscaleHeadroomAutomaticOutputReference | OceanAksNpAutoscalerAutoscaleHeadroomAutomatic): any;
export declare function oceanAksNpAutoscalerAutoscaleHeadroomAutomaticToHclTerraform(struct?: OceanAksNpAutoscalerAutoscaleHeadroomAutomaticOutputReference | OceanAksNpAutoscalerAutoscaleHeadroomAutomatic): any;
export declare class OceanAksNpAutoscalerAutoscaleHeadroomAutomaticOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpAutoscalerAutoscaleHeadroomAutomatic | undefined;
    set internalValue(value: OceanAksNpAutoscalerAutoscaleHeadroomAutomatic | undefined);
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _percentage?;
    get percentage(): number;
    set percentage(value: number);
    resetPercentage(): void;
    get percentageInput(): number | undefined;
}
export interface OceanAksNpAutoscalerAutoscaleHeadroom {
    /**
    * automatic block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#automatic OceanAksNp#automatic}
    */
    readonly automatic?: OceanAksNpAutoscalerAutoscaleHeadroomAutomatic;
}
export declare function oceanAksNpAutoscalerAutoscaleHeadroomToTerraform(struct?: OceanAksNpAutoscalerAutoscaleHeadroomOutputReference | OceanAksNpAutoscalerAutoscaleHeadroom): any;
export declare function oceanAksNpAutoscalerAutoscaleHeadroomToHclTerraform(struct?: OceanAksNpAutoscalerAutoscaleHeadroomOutputReference | OceanAksNpAutoscalerAutoscaleHeadroom): any;
export declare class OceanAksNpAutoscalerAutoscaleHeadroomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpAutoscalerAutoscaleHeadroom | undefined;
    set internalValue(value: OceanAksNpAutoscalerAutoscaleHeadroom | undefined);
    private _automatic;
    get automatic(): OceanAksNpAutoscalerAutoscaleHeadroomAutomaticOutputReference;
    putAutomatic(value: OceanAksNpAutoscalerAutoscaleHeadroomAutomatic): void;
    resetAutomatic(): void;
    get automaticInput(): OceanAksNpAutoscalerAutoscaleHeadroomAutomatic | undefined;
}
export interface OceanAksNpAutoscalerResourceLimits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#max_memory_gib OceanAksNp#max_memory_gib}
    */
    readonly maxMemoryGib?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#max_vcpu OceanAksNp#max_vcpu}
    */
    readonly maxVcpu?: number;
}
export declare function oceanAksNpAutoscalerResourceLimitsToTerraform(struct?: OceanAksNpAutoscalerResourceLimitsOutputReference | OceanAksNpAutoscalerResourceLimits): any;
export declare function oceanAksNpAutoscalerResourceLimitsToHclTerraform(struct?: OceanAksNpAutoscalerResourceLimitsOutputReference | OceanAksNpAutoscalerResourceLimits): any;
export declare class OceanAksNpAutoscalerResourceLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpAutoscalerResourceLimits | undefined;
    set internalValue(value: OceanAksNpAutoscalerResourceLimits | undefined);
    private _maxMemoryGib?;
    get maxMemoryGib(): number;
    set maxMemoryGib(value: number);
    resetMaxMemoryGib(): void;
    get maxMemoryGibInput(): number | undefined;
    private _maxVcpu?;
    get maxVcpu(): number;
    set maxVcpu(value: number);
    resetMaxVcpu(): void;
    get maxVcpuInput(): number | undefined;
}
export interface OceanAksNpAutoscaler {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#autoscale_is_enabled OceanAksNp#autoscale_is_enabled}
    */
    readonly autoscaleIsEnabled?: boolean | cdktf.IResolvable;
    /**
    * autoscale_down block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#autoscale_down OceanAksNp#autoscale_down}
    */
    readonly autoscaleDown?: OceanAksNpAutoscalerAutoscaleDown;
    /**
    * autoscale_headroom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#autoscale_headroom OceanAksNp#autoscale_headroom}
    */
    readonly autoscaleHeadroom?: OceanAksNpAutoscalerAutoscaleHeadroom;
    /**
    * resource_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#resource_limits OceanAksNp#resource_limits}
    */
    readonly resourceLimits?: OceanAksNpAutoscalerResourceLimits;
}
export declare function oceanAksNpAutoscalerToTerraform(struct?: OceanAksNpAutoscalerOutputReference | OceanAksNpAutoscaler): any;
export declare function oceanAksNpAutoscalerToHclTerraform(struct?: OceanAksNpAutoscalerOutputReference | OceanAksNpAutoscaler): any;
export declare class OceanAksNpAutoscalerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpAutoscaler | undefined;
    set internalValue(value: OceanAksNpAutoscaler | undefined);
    private _autoscaleIsEnabled?;
    get autoscaleIsEnabled(): boolean | cdktf.IResolvable;
    set autoscaleIsEnabled(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsEnabled(): void;
    get autoscaleIsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _autoscaleDown;
    get autoscaleDown(): OceanAksNpAutoscalerAutoscaleDownOutputReference;
    putAutoscaleDown(value: OceanAksNpAutoscalerAutoscaleDown): void;
    resetAutoscaleDown(): void;
    get autoscaleDownInput(): OceanAksNpAutoscalerAutoscaleDown | undefined;
    private _autoscaleHeadroom;
    get autoscaleHeadroom(): OceanAksNpAutoscalerAutoscaleHeadroomOutputReference;
    putAutoscaleHeadroom(value: OceanAksNpAutoscalerAutoscaleHeadroom): void;
    resetAutoscaleHeadroom(): void;
    get autoscaleHeadroomInput(): OceanAksNpAutoscalerAutoscaleHeadroom | undefined;
    private _resourceLimits;
    get resourceLimits(): OceanAksNpAutoscalerResourceLimitsOutputReference;
    putResourceLimits(value: OceanAksNpAutoscalerResourceLimits): void;
    resetResourceLimits(): void;
    get resourceLimitsInput(): OceanAksNpAutoscalerResourceLimits | undefined;
}
export interface OceanAksNpFilters {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#accelerated_networking OceanAksNp#accelerated_networking}
    */
    readonly acceleratedNetworking?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#architectures OceanAksNp#architectures}
    */
    readonly architectures?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#disk_performance OceanAksNp#disk_performance}
    */
    readonly diskPerformance?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#exclude_series OceanAksNp#exclude_series}
    */
    readonly excludeSeries?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#gpu_types OceanAksNp#gpu_types}
    */
    readonly gpuTypes?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#max_gpu OceanAksNp#max_gpu}
    */
    readonly maxGpu?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#max_memory_gib OceanAksNp#max_memory_gib}
    */
    readonly maxMemoryGib?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#max_vcpu OceanAksNp#max_vcpu}
    */
    readonly maxVcpu?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#min_disk OceanAksNp#min_disk}
    */
    readonly minDisk?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#min_gpu OceanAksNp#min_gpu}
    */
    readonly minGpu?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#min_memory_gib OceanAksNp#min_memory_gib}
    */
    readonly minMemoryGib?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#min_nics OceanAksNp#min_nics}
    */
    readonly minNics?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#min_vcpu OceanAksNp#min_vcpu}
    */
    readonly minVcpu?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#series OceanAksNp#series}
    */
    readonly series?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#vm_types OceanAksNp#vm_types}
    */
    readonly vmTypes?: string[];
}
export declare function oceanAksNpFiltersToTerraform(struct?: OceanAksNpFiltersOutputReference | OceanAksNpFilters): any;
export declare function oceanAksNpFiltersToHclTerraform(struct?: OceanAksNpFiltersOutputReference | OceanAksNpFilters): any;
export declare class OceanAksNpFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpFilters | undefined;
    set internalValue(value: OceanAksNpFilters | undefined);
    private _acceleratedNetworking?;
    get acceleratedNetworking(): string;
    set acceleratedNetworking(value: string);
    resetAcceleratedNetworking(): void;
    get acceleratedNetworkingInput(): string | undefined;
    private _architectures?;
    get architectures(): string[];
    set architectures(value: string[]);
    resetArchitectures(): void;
    get architecturesInput(): string[] | undefined;
    private _diskPerformance?;
    get diskPerformance(): string;
    set diskPerformance(value: string);
    resetDiskPerformance(): void;
    get diskPerformanceInput(): string | undefined;
    private _excludeSeries?;
    get excludeSeries(): string[];
    set excludeSeries(value: string[]);
    resetExcludeSeries(): void;
    get excludeSeriesInput(): string[] | undefined;
    private _gpuTypes?;
    get gpuTypes(): string[];
    set gpuTypes(value: string[]);
    resetGpuTypes(): void;
    get gpuTypesInput(): string[] | undefined;
    private _maxGpu?;
    get maxGpu(): number;
    set maxGpu(value: number);
    resetMaxGpu(): void;
    get maxGpuInput(): number | undefined;
    private _maxMemoryGib?;
    get maxMemoryGib(): number;
    set maxMemoryGib(value: number);
    resetMaxMemoryGib(): void;
    get maxMemoryGibInput(): number | undefined;
    private _maxVcpu?;
    get maxVcpu(): number;
    set maxVcpu(value: number);
    resetMaxVcpu(): void;
    get maxVcpuInput(): number | undefined;
    private _minDisk?;
    get minDisk(): number;
    set minDisk(value: number);
    resetMinDisk(): void;
    get minDiskInput(): number | undefined;
    private _minGpu?;
    get minGpu(): number;
    set minGpu(value: number);
    resetMinGpu(): void;
    get minGpuInput(): number | undefined;
    private _minMemoryGib?;
    get minMemoryGib(): number;
    set minMemoryGib(value: number);
    resetMinMemoryGib(): void;
    get minMemoryGibInput(): number | undefined;
    private _minNics?;
    get minNics(): number;
    set minNics(value: number);
    resetMinNics(): void;
    get minNicsInput(): number | undefined;
    private _minVcpu?;
    get minVcpu(): number;
    set minVcpu(value: number);
    resetMinVcpu(): void;
    get minVcpuInput(): number | undefined;
    private _series?;
    get series(): string[];
    set series(value: string[]);
    resetSeries(): void;
    get seriesInput(): string[] | undefined;
    private _vmTypes?;
    get vmTypes(): string[];
    set vmTypes(value: string[]);
    resetVmTypes(): void;
    get vmTypesInput(): string[] | undefined;
}
export interface OceanAksNpHeadrooms {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#cpu_per_unit OceanAksNp#cpu_per_unit}
    */
    readonly cpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#gpu_per_unit OceanAksNp#gpu_per_unit}
    */
    readonly gpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#memory_per_unit OceanAksNp#memory_per_unit}
    */
    readonly memoryPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#num_of_units OceanAksNp#num_of_units}
    */
    readonly numOfUnits?: number;
}
export declare function oceanAksNpHeadroomsToTerraform(struct?: OceanAksNpHeadrooms | cdktf.IResolvable): any;
export declare function oceanAksNpHeadroomsToHclTerraform(struct?: OceanAksNpHeadrooms | cdktf.IResolvable): any;
export declare class OceanAksNpHeadroomsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanAksNpHeadrooms | cdktf.IResolvable | undefined;
    set internalValue(value: OceanAksNpHeadrooms | cdktf.IResolvable | undefined);
    private _cpuPerUnit?;
    get cpuPerUnit(): number;
    set cpuPerUnit(value: number);
    resetCpuPerUnit(): void;
    get cpuPerUnitInput(): number | undefined;
    private _gpuPerUnit?;
    get gpuPerUnit(): number;
    set gpuPerUnit(value: number);
    resetGpuPerUnit(): void;
    get gpuPerUnitInput(): number | undefined;
    private _memoryPerUnit?;
    get memoryPerUnit(): number;
    set memoryPerUnit(value: number);
    resetMemoryPerUnit(): void;
    get memoryPerUnitInput(): number | undefined;
    private _numOfUnits?;
    get numOfUnits(): number;
    set numOfUnits(value: number);
    resetNumOfUnits(): void;
    get numOfUnitsInput(): number | undefined;
}
export declare class OceanAksNpHeadroomsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanAksNpHeadrooms[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanAksNpHeadroomsOutputReference;
}
export interface OceanAksNpHealth {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#grace_period OceanAksNp#grace_period}
    */
    readonly gracePeriod?: number;
}
export declare function oceanAksNpHealthToTerraform(struct?: OceanAksNpHealthOutputReference | OceanAksNpHealth): any;
export declare function oceanAksNpHealthToHclTerraform(struct?: OceanAksNpHealthOutputReference | OceanAksNpHealth): any;
export declare class OceanAksNpHealthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpHealth | undefined;
    set internalValue(value: OceanAksNpHealth | undefined);
    private _gracePeriod?;
    get gracePeriod(): number;
    set gracePeriod(value: number);
    resetGracePeriod(): void;
    get gracePeriodInput(): number | undefined;
}
export interface OceanAksNpLinuxOsConfigSysctls {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#vm_max_map_count OceanAksNp#vm_max_map_count}
    */
    readonly vmMaxMapCount?: number;
}
export declare function oceanAksNpLinuxOsConfigSysctlsToTerraform(struct?: OceanAksNpLinuxOsConfigSysctls | cdktf.IResolvable): any;
export declare function oceanAksNpLinuxOsConfigSysctlsToHclTerraform(struct?: OceanAksNpLinuxOsConfigSysctls | cdktf.IResolvable): any;
export declare class OceanAksNpLinuxOsConfigSysctlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanAksNpLinuxOsConfigSysctls | cdktf.IResolvable | undefined;
    set internalValue(value: OceanAksNpLinuxOsConfigSysctls | cdktf.IResolvable | undefined);
    private _vmMaxMapCount?;
    get vmMaxMapCount(): number;
    set vmMaxMapCount(value: number);
    resetVmMaxMapCount(): void;
    get vmMaxMapCountInput(): number | undefined;
}
export declare class OceanAksNpLinuxOsConfigSysctlsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanAksNpLinuxOsConfigSysctls[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanAksNpLinuxOsConfigSysctlsOutputReference;
}
export interface OceanAksNpLinuxOsConfig {
    /**
    * sysctls block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#sysctls OceanAksNp#sysctls}
    */
    readonly sysctls?: OceanAksNpLinuxOsConfigSysctls[] | cdktf.IResolvable;
}
export declare function oceanAksNpLinuxOsConfigToTerraform(struct?: OceanAksNpLinuxOsConfig | cdktf.IResolvable): any;
export declare function oceanAksNpLinuxOsConfigToHclTerraform(struct?: OceanAksNpLinuxOsConfig | cdktf.IResolvable): any;
export declare class OceanAksNpLinuxOsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanAksNpLinuxOsConfig | cdktf.IResolvable | undefined;
    set internalValue(value: OceanAksNpLinuxOsConfig | cdktf.IResolvable | undefined);
    private _sysctls;
    get sysctls(): OceanAksNpLinuxOsConfigSysctlsList;
    putSysctls(value: OceanAksNpLinuxOsConfigSysctls[] | cdktf.IResolvable): void;
    resetSysctls(): void;
    get sysctlsInput(): cdktf.IResolvable | OceanAksNpLinuxOsConfigSysctls[] | undefined;
}
export declare class OceanAksNpLinuxOsConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanAksNpLinuxOsConfig[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanAksNpLinuxOsConfigOutputReference;
}
export interface OceanAksNpLoggingExportAzureBlob {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#id OceanAksNp#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export declare function oceanAksNpLoggingExportAzureBlobToTerraform(struct?: OceanAksNpLoggingExportAzureBlob | cdktf.IResolvable): any;
export declare function oceanAksNpLoggingExportAzureBlobToHclTerraform(struct?: OceanAksNpLoggingExportAzureBlob | cdktf.IResolvable): any;
export declare class OceanAksNpLoggingExportAzureBlobOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanAksNpLoggingExportAzureBlob | cdktf.IResolvable | undefined;
    set internalValue(value: OceanAksNpLoggingExportAzureBlob | cdktf.IResolvable | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
}
export declare class OceanAksNpLoggingExportAzureBlobList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanAksNpLoggingExportAzureBlob[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanAksNpLoggingExportAzureBlobOutputReference;
}
export interface OceanAksNpLoggingExport {
    /**
    * azure_blob block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#azure_blob OceanAksNp#azure_blob}
    */
    readonly azureBlob?: OceanAksNpLoggingExportAzureBlob[] | cdktf.IResolvable;
}
export declare function oceanAksNpLoggingExportToTerraform(struct?: OceanAksNpLoggingExportOutputReference | OceanAksNpLoggingExport): any;
export declare function oceanAksNpLoggingExportToHclTerraform(struct?: OceanAksNpLoggingExportOutputReference | OceanAksNpLoggingExport): any;
export declare class OceanAksNpLoggingExportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpLoggingExport | undefined;
    set internalValue(value: OceanAksNpLoggingExport | undefined);
    private _azureBlob;
    get azureBlob(): OceanAksNpLoggingExportAzureBlobList;
    putAzureBlob(value: OceanAksNpLoggingExportAzureBlob[] | cdktf.IResolvable): void;
    resetAzureBlob(): void;
    get azureBlobInput(): cdktf.IResolvable | OceanAksNpLoggingExportAzureBlob[] | undefined;
}
export interface OceanAksNpLogging {
    /**
    * export block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#export OceanAksNp#export}
    */
    readonly export?: OceanAksNpLoggingExport;
}
export declare function oceanAksNpLoggingToTerraform(struct?: OceanAksNpLoggingOutputReference | OceanAksNpLogging): any;
export declare function oceanAksNpLoggingToHclTerraform(struct?: OceanAksNpLoggingOutputReference | OceanAksNpLogging): any;
export declare class OceanAksNpLoggingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpLogging | undefined;
    set internalValue(value: OceanAksNpLogging | undefined);
    private _export;
    get export(): OceanAksNpLoggingExportOutputReference;
    putExport(value: OceanAksNpLoggingExport): void;
    resetExport(): void;
    get exportInput(): OceanAksNpLoggingExport | undefined;
}
export interface OceanAksNpSchedulingShutdownHours {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#is_enabled OceanAksNp#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#time_windows OceanAksNp#time_windows}
    */
    readonly timeWindows?: string[];
}
export declare function oceanAksNpSchedulingShutdownHoursToTerraform(struct?: OceanAksNpSchedulingShutdownHoursOutputReference | OceanAksNpSchedulingShutdownHours): any;
export declare function oceanAksNpSchedulingShutdownHoursToHclTerraform(struct?: OceanAksNpSchedulingShutdownHoursOutputReference | OceanAksNpSchedulingShutdownHours): any;
export declare class OceanAksNpSchedulingShutdownHoursOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpSchedulingShutdownHours | undefined;
    set internalValue(value: OceanAksNpSchedulingShutdownHours | undefined);
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _timeWindows?;
    get timeWindows(): string[];
    set timeWindows(value: string[]);
    resetTimeWindows(): void;
    get timeWindowsInput(): string[] | undefined;
}
export interface OceanAksNpSchedulingSuspensionHours {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#is_enabled OceanAksNp#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#time_windows OceanAksNp#time_windows}
    */
    readonly timeWindows?: string[];
}
export declare function oceanAksNpSchedulingSuspensionHoursToTerraform(struct?: OceanAksNpSchedulingSuspensionHoursOutputReference | OceanAksNpSchedulingSuspensionHours): any;
export declare function oceanAksNpSchedulingSuspensionHoursToHclTerraform(struct?: OceanAksNpSchedulingSuspensionHoursOutputReference | OceanAksNpSchedulingSuspensionHours): any;
export declare class OceanAksNpSchedulingSuspensionHoursOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpSchedulingSuspensionHours | undefined;
    set internalValue(value: OceanAksNpSchedulingSuspensionHours | undefined);
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _timeWindows?;
    get timeWindows(): string[];
    set timeWindows(value: string[]);
    resetTimeWindows(): void;
    get timeWindowsInput(): string[] | undefined;
}
export interface OceanAksNpSchedulingTasksParametersParametersClusterRoll {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#batch_min_healthy_percentage OceanAksNp#batch_min_healthy_percentage}
    */
    readonly batchMinHealthyPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#batch_size_percentage OceanAksNp#batch_size_percentage}
    */
    readonly batchSizePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#comment OceanAksNp#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#respect_pdb OceanAksNp#respect_pdb}
    */
    readonly respectPdb?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#respect_restrict_scale_down OceanAksNp#respect_restrict_scale_down}
    */
    readonly respectRestrictScaleDown?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#vng_ids OceanAksNp#vng_ids}
    */
    readonly vngIds?: string[];
}
export declare function oceanAksNpSchedulingTasksParametersParametersClusterRollToTerraform(struct?: OceanAksNpSchedulingTasksParametersParametersClusterRollOutputReference | OceanAksNpSchedulingTasksParametersParametersClusterRoll): any;
export declare function oceanAksNpSchedulingTasksParametersParametersClusterRollToHclTerraform(struct?: OceanAksNpSchedulingTasksParametersParametersClusterRollOutputReference | OceanAksNpSchedulingTasksParametersParametersClusterRoll): any;
export declare class OceanAksNpSchedulingTasksParametersParametersClusterRollOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpSchedulingTasksParametersParametersClusterRoll | undefined;
    set internalValue(value: OceanAksNpSchedulingTasksParametersParametersClusterRoll | undefined);
    private _batchMinHealthyPercentage?;
    get batchMinHealthyPercentage(): number;
    set batchMinHealthyPercentage(value: number);
    resetBatchMinHealthyPercentage(): void;
    get batchMinHealthyPercentageInput(): number | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): number;
    set batchSizePercentage(value: number);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): number | undefined;
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    private _respectPdb?;
    get respectPdb(): boolean | cdktf.IResolvable;
    set respectPdb(value: boolean | cdktf.IResolvable);
    resetRespectPdb(): void;
    get respectPdbInput(): boolean | cdktf.IResolvable | undefined;
    private _respectRestrictScaleDown?;
    get respectRestrictScaleDown(): boolean | cdktf.IResolvable;
    set respectRestrictScaleDown(value: boolean | cdktf.IResolvable);
    resetRespectRestrictScaleDown(): void;
    get respectRestrictScaleDownInput(): boolean | cdktf.IResolvable | undefined;
    private _vngIds?;
    get vngIds(): string[];
    set vngIds(value: string[]);
    resetVngIds(): void;
    get vngIdsInput(): string[] | undefined;
}
export interface OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParameters {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#batch_min_healthy_percentage OceanAksNp#batch_min_healthy_percentage}
    */
    readonly batchMinHealthyPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#batch_size_percentage OceanAksNp#batch_size_percentage}
    */
    readonly batchSizePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#comment OceanAksNp#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#respect_pdb OceanAksNp#respect_pdb}
    */
    readonly respectPdb?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#respect_restrict_scale_down OceanAksNp#respect_restrict_scale_down}
    */
    readonly respectRestrictScaleDown?: boolean | cdktf.IResolvable;
}
export declare function oceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParametersToTerraform(struct?: OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParametersOutputReference | OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParameters): any;
export declare function oceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParametersToHclTerraform(struct?: OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParametersOutputReference | OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParameters): any;
export declare class OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParameters | undefined;
    set internalValue(value: OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParameters | undefined);
    private _batchMinHealthyPercentage?;
    get batchMinHealthyPercentage(): number;
    set batchMinHealthyPercentage(value: number);
    resetBatchMinHealthyPercentage(): void;
    get batchMinHealthyPercentageInput(): number | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): number;
    set batchSizePercentage(value: number);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): number | undefined;
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    private _respectPdb?;
    get respectPdb(): boolean | cdktf.IResolvable;
    set respectPdb(value: boolean | cdktf.IResolvable);
    resetRespectPdb(): void;
    get respectPdbInput(): boolean | cdktf.IResolvable | undefined;
    private _respectRestrictScaleDown?;
    get respectRestrictScaleDown(): boolean | cdktf.IResolvable;
    set respectRestrictScaleDown(value: boolean | cdktf.IResolvable);
    resetRespectRestrictScaleDown(): void;
    get respectRestrictScaleDownInput(): boolean | cdktf.IResolvable | undefined;
}
export interface OceanAksNpSchedulingTasksParametersParametersUpgradeConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#apply_roll OceanAksNp#apply_roll}
    */
    readonly applyRoll?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#scope_version OceanAksNp#scope_version}
    */
    readonly scopeVersion?: string;
    /**
    * roll_parameters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#roll_parameters OceanAksNp#roll_parameters}
    */
    readonly rollParameters?: OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParameters;
}
export declare function oceanAksNpSchedulingTasksParametersParametersUpgradeConfigToTerraform(struct?: OceanAksNpSchedulingTasksParametersParametersUpgradeConfigOutputReference | OceanAksNpSchedulingTasksParametersParametersUpgradeConfig): any;
export declare function oceanAksNpSchedulingTasksParametersParametersUpgradeConfigToHclTerraform(struct?: OceanAksNpSchedulingTasksParametersParametersUpgradeConfigOutputReference | OceanAksNpSchedulingTasksParametersParametersUpgradeConfig): any;
export declare class OceanAksNpSchedulingTasksParametersParametersUpgradeConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpSchedulingTasksParametersParametersUpgradeConfig | undefined;
    set internalValue(value: OceanAksNpSchedulingTasksParametersParametersUpgradeConfig | undefined);
    private _applyRoll?;
    get applyRoll(): boolean | cdktf.IResolvable;
    set applyRoll(value: boolean | cdktf.IResolvable);
    resetApplyRoll(): void;
    get applyRollInput(): boolean | cdktf.IResolvable | undefined;
    private _scopeVersion?;
    get scopeVersion(): string;
    set scopeVersion(value: string);
    resetScopeVersion(): void;
    get scopeVersionInput(): string | undefined;
    private _rollParameters;
    get rollParameters(): OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParametersOutputReference;
    putRollParameters(value: OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParameters): void;
    resetRollParameters(): void;
    get rollParametersInput(): OceanAksNpSchedulingTasksParametersParametersUpgradeConfigRollParameters | undefined;
}
export interface OceanAksNpSchedulingTasksParameters {
    /**
    * parameters_cluster_roll block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#parameters_cluster_roll OceanAksNp#parameters_cluster_roll}
    */
    readonly parametersClusterRoll?: OceanAksNpSchedulingTasksParametersParametersClusterRoll;
    /**
    * parameters_upgrade_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#parameters_upgrade_config OceanAksNp#parameters_upgrade_config}
    */
    readonly parametersUpgradeConfig?: OceanAksNpSchedulingTasksParametersParametersUpgradeConfig;
}
export declare function oceanAksNpSchedulingTasksParametersToTerraform(struct?: OceanAksNpSchedulingTasksParametersOutputReference | OceanAksNpSchedulingTasksParameters): any;
export declare function oceanAksNpSchedulingTasksParametersToHclTerraform(struct?: OceanAksNpSchedulingTasksParametersOutputReference | OceanAksNpSchedulingTasksParameters): any;
export declare class OceanAksNpSchedulingTasksParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpSchedulingTasksParameters | undefined;
    set internalValue(value: OceanAksNpSchedulingTasksParameters | undefined);
    private _parametersClusterRoll;
    get parametersClusterRoll(): OceanAksNpSchedulingTasksParametersParametersClusterRollOutputReference;
    putParametersClusterRoll(value: OceanAksNpSchedulingTasksParametersParametersClusterRoll): void;
    resetParametersClusterRoll(): void;
    get parametersClusterRollInput(): OceanAksNpSchedulingTasksParametersParametersClusterRoll | undefined;
    private _parametersUpgradeConfig;
    get parametersUpgradeConfig(): OceanAksNpSchedulingTasksParametersParametersUpgradeConfigOutputReference;
    putParametersUpgradeConfig(value: OceanAksNpSchedulingTasksParametersParametersUpgradeConfig): void;
    resetParametersUpgradeConfig(): void;
    get parametersUpgradeConfigInput(): OceanAksNpSchedulingTasksParametersParametersUpgradeConfig | undefined;
}
export interface OceanAksNpSchedulingTasks {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#cron_expression OceanAksNp#cron_expression}
    */
    readonly cronExpression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#is_enabled OceanAksNp#is_enabled}
    */
    readonly isEnabled: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#task_type OceanAksNp#task_type}
    */
    readonly taskType: string;
    /**
    * parameters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#parameters OceanAksNp#parameters}
    */
    readonly parameters?: OceanAksNpSchedulingTasksParameters;
}
export declare function oceanAksNpSchedulingTasksToTerraform(struct?: OceanAksNpSchedulingTasks | cdktf.IResolvable): any;
export declare function oceanAksNpSchedulingTasksToHclTerraform(struct?: OceanAksNpSchedulingTasks | cdktf.IResolvable): any;
export declare class OceanAksNpSchedulingTasksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanAksNpSchedulingTasks | cdktf.IResolvable | undefined;
    set internalValue(value: OceanAksNpSchedulingTasks | cdktf.IResolvable | undefined);
    private _cronExpression?;
    get cronExpression(): string;
    set cronExpression(value: string);
    get cronExpressionInput(): string | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _taskType?;
    get taskType(): string;
    set taskType(value: string);
    get taskTypeInput(): string | undefined;
    private _parameters;
    get parameters(): OceanAksNpSchedulingTasksParametersOutputReference;
    putParameters(value: OceanAksNpSchedulingTasksParameters): void;
    resetParameters(): void;
    get parametersInput(): OceanAksNpSchedulingTasksParameters | undefined;
}
export declare class OceanAksNpSchedulingTasksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanAksNpSchedulingTasks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanAksNpSchedulingTasksOutputReference;
}
export interface OceanAksNpScheduling {
    /**
    * shutdown_hours block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#shutdown_hours OceanAksNp#shutdown_hours}
    */
    readonly shutdownHours?: OceanAksNpSchedulingShutdownHours;
    /**
    * suspension_hours block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#suspension_hours OceanAksNp#suspension_hours}
    */
    readonly suspensionHours?: OceanAksNpSchedulingSuspensionHours;
    /**
    * tasks block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#tasks OceanAksNp#tasks}
    */
    readonly tasks?: OceanAksNpSchedulingTasks[] | cdktf.IResolvable;
}
export declare function oceanAksNpSchedulingToTerraform(struct?: OceanAksNpSchedulingOutputReference | OceanAksNpScheduling): any;
export declare function oceanAksNpSchedulingToHclTerraform(struct?: OceanAksNpSchedulingOutputReference | OceanAksNpScheduling): any;
export declare class OceanAksNpSchedulingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpScheduling | undefined;
    set internalValue(value: OceanAksNpScheduling | undefined);
    private _shutdownHours;
    get shutdownHours(): OceanAksNpSchedulingShutdownHoursOutputReference;
    putShutdownHours(value: OceanAksNpSchedulingShutdownHours): void;
    resetShutdownHours(): void;
    get shutdownHoursInput(): OceanAksNpSchedulingShutdownHours | undefined;
    private _suspensionHours;
    get suspensionHours(): OceanAksNpSchedulingSuspensionHoursOutputReference;
    putSuspensionHours(value: OceanAksNpSchedulingSuspensionHours): void;
    resetSuspensionHours(): void;
    get suspensionHoursInput(): OceanAksNpSchedulingSuspensionHours | undefined;
    private _tasks;
    get tasks(): OceanAksNpSchedulingTasksList;
    putTasks(value: OceanAksNpSchedulingTasks[] | cdktf.IResolvable): void;
    resetTasks(): void;
    get tasksInput(): cdktf.IResolvable | OceanAksNpSchedulingTasks[] | undefined;
}
export interface OceanAksNpTaints {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#effect OceanAksNp#effect}
    */
    readonly effect: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#key OceanAksNp#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#value OceanAksNp#value}
    */
    readonly value: string;
}
export declare function oceanAksNpTaintsToTerraform(struct?: OceanAksNpTaints | cdktf.IResolvable): any;
export declare function oceanAksNpTaintsToHclTerraform(struct?: OceanAksNpTaints | cdktf.IResolvable): any;
export declare class OceanAksNpTaintsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanAksNpTaints | cdktf.IResolvable | undefined;
    set internalValue(value: OceanAksNpTaints | cdktf.IResolvable | undefined);
    private _effect?;
    get effect(): string;
    set effect(value: string);
    get effectInput(): string | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class OceanAksNpTaintsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanAksNpTaints[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanAksNpTaintsOutputReference;
}
export interface OceanAksNpUpdatePolicyRollConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#batch_min_healthy_percentage OceanAksNp#batch_min_healthy_percentage}
    */
    readonly batchMinHealthyPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#batch_size_percentage OceanAksNp#batch_size_percentage}
    */
    readonly batchSizePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#comment OceanAksNp#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#node_names OceanAksNp#node_names}
    */
    readonly nodeNames?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#node_pool_names OceanAksNp#node_pool_names}
    */
    readonly nodePoolNames?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#respect_pdb OceanAksNp#respect_pdb}
    */
    readonly respectPdb?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#respect_restrict_scale_down OceanAksNp#respect_restrict_scale_down}
    */
    readonly respectRestrictScaleDown?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#vng_ids OceanAksNp#vng_ids}
    */
    readonly vngIds?: string[];
}
export declare function oceanAksNpUpdatePolicyRollConfigToTerraform(struct?: OceanAksNpUpdatePolicyRollConfigOutputReference | OceanAksNpUpdatePolicyRollConfig): any;
export declare function oceanAksNpUpdatePolicyRollConfigToHclTerraform(struct?: OceanAksNpUpdatePolicyRollConfigOutputReference | OceanAksNpUpdatePolicyRollConfig): any;
export declare class OceanAksNpUpdatePolicyRollConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpUpdatePolicyRollConfig | undefined;
    set internalValue(value: OceanAksNpUpdatePolicyRollConfig | undefined);
    private _batchMinHealthyPercentage?;
    get batchMinHealthyPercentage(): number;
    set batchMinHealthyPercentage(value: number);
    resetBatchMinHealthyPercentage(): void;
    get batchMinHealthyPercentageInput(): number | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): number;
    set batchSizePercentage(value: number);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): number | undefined;
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    private _nodeNames?;
    get nodeNames(): string[];
    set nodeNames(value: string[]);
    resetNodeNames(): void;
    get nodeNamesInput(): string[] | undefined;
    private _nodePoolNames?;
    get nodePoolNames(): string[];
    set nodePoolNames(value: string[]);
    resetNodePoolNames(): void;
    get nodePoolNamesInput(): string[] | undefined;
    private _respectPdb?;
    get respectPdb(): boolean | cdktf.IResolvable;
    set respectPdb(value: boolean | cdktf.IResolvable);
    resetRespectPdb(): void;
    get respectPdbInput(): boolean | cdktf.IResolvable | undefined;
    private _respectRestrictScaleDown?;
    get respectRestrictScaleDown(): boolean | cdktf.IResolvable;
    set respectRestrictScaleDown(value: boolean | cdktf.IResolvable);
    resetRespectRestrictScaleDown(): void;
    get respectRestrictScaleDownInput(): boolean | cdktf.IResolvable | undefined;
    private _vngIds?;
    get vngIds(): string[];
    set vngIds(value: string[]);
    resetVngIds(): void;
    get vngIdsInput(): string[] | undefined;
}
export interface OceanAksNpUpdatePolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#conditioned_roll OceanAksNp#conditioned_roll}
    */
    readonly conditionedRoll?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#should_roll OceanAksNp#should_roll}
    */
    readonly shouldRoll: boolean | cdktf.IResolvable;
    /**
    * roll_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#roll_config OceanAksNp#roll_config}
    */
    readonly rollConfig?: OceanAksNpUpdatePolicyRollConfig;
}
export declare function oceanAksNpUpdatePolicyToTerraform(struct?: OceanAksNpUpdatePolicyOutputReference | OceanAksNpUpdatePolicy): any;
export declare function oceanAksNpUpdatePolicyToHclTerraform(struct?: OceanAksNpUpdatePolicyOutputReference | OceanAksNpUpdatePolicy): any;
export declare class OceanAksNpUpdatePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpUpdatePolicy | undefined;
    set internalValue(value: OceanAksNpUpdatePolicy | undefined);
    private _conditionedRoll?;
    get conditionedRoll(): boolean | cdktf.IResolvable;
    set conditionedRoll(value: boolean | cdktf.IResolvable);
    resetConditionedRoll(): void;
    get conditionedRollInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldRoll?;
    get shouldRoll(): boolean | cdktf.IResolvable;
    set shouldRoll(value: boolean | cdktf.IResolvable);
    get shouldRollInput(): boolean | cdktf.IResolvable | undefined;
    private _rollConfig;
    get rollConfig(): OceanAksNpUpdatePolicyRollConfigOutputReference;
    putRollConfig(value: OceanAksNpUpdatePolicyRollConfig): void;
    resetRollConfig(): void;
    get rollConfigInput(): OceanAksNpUpdatePolicyRollConfig | undefined;
}
export interface OceanAksNpVngTemplateSchedulingVngTemplateShutdownHours {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#is_enabled OceanAksNp#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#time_windows OceanAksNp#time_windows}
    */
    readonly timeWindows?: string[];
}
export declare function oceanAksNpVngTemplateSchedulingVngTemplateShutdownHoursToTerraform(struct?: OceanAksNpVngTemplateSchedulingVngTemplateShutdownHoursOutputReference | OceanAksNpVngTemplateSchedulingVngTemplateShutdownHours): any;
export declare function oceanAksNpVngTemplateSchedulingVngTemplateShutdownHoursToHclTerraform(struct?: OceanAksNpVngTemplateSchedulingVngTemplateShutdownHoursOutputReference | OceanAksNpVngTemplateSchedulingVngTemplateShutdownHours): any;
export declare class OceanAksNpVngTemplateSchedulingVngTemplateShutdownHoursOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpVngTemplateSchedulingVngTemplateShutdownHours | undefined;
    set internalValue(value: OceanAksNpVngTemplateSchedulingVngTemplateShutdownHours | undefined);
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _timeWindows?;
    get timeWindows(): string[];
    set timeWindows(value: string[]);
    resetTimeWindows(): void;
    get timeWindowsInput(): string[] | undefined;
}
export interface OceanAksNpVngTemplateScheduling {
    /**
    * vng_template_shutdown_hours block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#vng_template_shutdown_hours OceanAksNp#vng_template_shutdown_hours}
    */
    readonly vngTemplateShutdownHours?: OceanAksNpVngTemplateSchedulingVngTemplateShutdownHours;
}
export declare function oceanAksNpVngTemplateSchedulingToTerraform(struct?: OceanAksNpVngTemplateSchedulingOutputReference | OceanAksNpVngTemplateScheduling): any;
export declare function oceanAksNpVngTemplateSchedulingToHclTerraform(struct?: OceanAksNpVngTemplateSchedulingOutputReference | OceanAksNpVngTemplateScheduling): any;
export declare class OceanAksNpVngTemplateSchedulingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanAksNpVngTemplateScheduling | undefined;
    set internalValue(value: OceanAksNpVngTemplateScheduling | undefined);
    private _vngTemplateShutdownHours;
    get vngTemplateShutdownHours(): OceanAksNpVngTemplateSchedulingVngTemplateShutdownHoursOutputReference;
    putVngTemplateShutdownHours(value: OceanAksNpVngTemplateSchedulingVngTemplateShutdownHours): void;
    resetVngTemplateShutdownHours(): void;
    get vngTemplateShutdownHoursInput(): OceanAksNpVngTemplateSchedulingVngTemplateShutdownHours | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np spotinst_ocean_aks_np}
*/
export declare class OceanAksNp extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_ocean_aks_np";
    /**
    * Generates CDKTF code for importing a OceanAksNp resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OceanAksNp to import
    * @param importFromId The id of the existing OceanAksNp that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OceanAksNp to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/ocean_aks_np spotinst_ocean_aks_np} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OceanAksNpConfig
    */
    constructor(scope: Construct, id: string, config: OceanAksNpConfig);
    private _aksClusterName?;
    get aksClusterName(): string;
    set aksClusterName(value: string);
    get aksClusterNameInput(): string | undefined;
    private _aksInfrastructureResourceGroupName?;
    get aksInfrastructureResourceGroupName(): string;
    set aksInfrastructureResourceGroupName(value: string);
    get aksInfrastructureResourceGroupNameInput(): string | undefined;
    private _aksRegion?;
    get aksRegion(): string;
    set aksRegion(value: string);
    get aksRegionInput(): string | undefined;
    private _aksResourceGroupName?;
    get aksResourceGroupName(): string;
    set aksResourceGroupName(value: string);
    get aksResourceGroupNameInput(): string | undefined;
    private _availabilityZones?;
    get availabilityZones(): string[];
    set availabilityZones(value: string[]);
    get availabilityZonesInput(): string[] | undefined;
    private _controllerClusterId?;
    get controllerClusterId(): string;
    set controllerClusterId(value: string);
    get controllerClusterIdInput(): string | undefined;
    private _enableNodePublicIp?;
    get enableNodePublicIp(): boolean | cdktf.IResolvable;
    set enableNodePublicIp(value: boolean | cdktf.IResolvable);
    resetEnableNodePublicIp(): void;
    get enableNodePublicIpInput(): boolean | cdktf.IResolvable | undefined;
    private _fallbackToOndemand?;
    get fallbackToOndemand(): boolean | cdktf.IResolvable;
    set fallbackToOndemand(value: boolean | cdktf.IResolvable);
    resetFallbackToOndemand(): void;
    get fallbackToOndemandInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _kubernetesVersion?;
    get kubernetesVersion(): string;
    set kubernetesVersion(value: string);
    resetKubernetesVersion(): void;
    get kubernetesVersionInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _maxCount?;
    get maxCount(): number;
    set maxCount(value: number);
    resetMaxCount(): void;
    get maxCountInput(): number | undefined;
    private _maxPodsPerNode?;
    get maxPodsPerNode(): number;
    set maxPodsPerNode(value: number);
    resetMaxPodsPerNode(): void;
    get maxPodsPerNodeInput(): number | undefined;
    private _minCount?;
    get minCount(): number;
    set minCount(value: number);
    resetMinCount(): void;
    get minCountInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _osDiskSizeGb?;
    get osDiskSizeGb(): number;
    set osDiskSizeGb(value: number);
    resetOsDiskSizeGb(): void;
    get osDiskSizeGbInput(): number | undefined;
    private _osDiskType?;
    get osDiskType(): string;
    set osDiskType(value: string);
    resetOsDiskType(): void;
    get osDiskTypeInput(): string | undefined;
    private _osSku?;
    get osSku(): string;
    set osSku(value: string);
    resetOsSku(): void;
    get osSkuInput(): string | undefined;
    private _osType?;
    get osType(): string;
    set osType(value: string);
    resetOsType(): void;
    get osTypeInput(): string | undefined;
    private _podSubnetIds?;
    get podSubnetIds(): string[];
    set podSubnetIds(value: string[]);
    resetPodSubnetIds(): void;
    get podSubnetIdsInput(): string[] | undefined;
    private _spotPercentage?;
    get spotPercentage(): number;
    set spotPercentage(value: number);
    resetSpotPercentage(): void;
    get spotPercentageInput(): number | undefined;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vnetSubnetIds?;
    get vnetSubnetIds(): string[];
    set vnetSubnetIds(value: string[]);
    resetVnetSubnetIds(): void;
    get vnetSubnetIdsInput(): string[] | undefined;
    private _autoscaler;
    get autoscaler(): OceanAksNpAutoscalerOutputReference;
    putAutoscaler(value: OceanAksNpAutoscaler): void;
    resetAutoscaler(): void;
    get autoscalerInput(): OceanAksNpAutoscaler | undefined;
    private _filters;
    get filters(): OceanAksNpFiltersOutputReference;
    putFilters(value: OceanAksNpFilters): void;
    resetFilters(): void;
    get filtersInput(): OceanAksNpFilters | undefined;
    private _headrooms;
    get headrooms(): OceanAksNpHeadroomsList;
    putHeadrooms(value: OceanAksNpHeadrooms[] | cdktf.IResolvable): void;
    resetHeadrooms(): void;
    get headroomsInput(): cdktf.IResolvable | OceanAksNpHeadrooms[] | undefined;
    private _health;
    get health(): OceanAksNpHealthOutputReference;
    putHealth(value: OceanAksNpHealth): void;
    resetHealth(): void;
    get healthInput(): OceanAksNpHealth | undefined;
    private _linuxOsConfig;
    get linuxOsConfig(): OceanAksNpLinuxOsConfigList;
    putLinuxOsConfig(value: OceanAksNpLinuxOsConfig[] | cdktf.IResolvable): void;
    resetLinuxOsConfig(): void;
    get linuxOsConfigInput(): cdktf.IResolvable | OceanAksNpLinuxOsConfig[] | undefined;
    private _logging;
    get logging(): OceanAksNpLoggingOutputReference;
    putLogging(value: OceanAksNpLogging): void;
    resetLogging(): void;
    get loggingInput(): OceanAksNpLogging | undefined;
    private _scheduling;
    get scheduling(): OceanAksNpSchedulingOutputReference;
    putScheduling(value: OceanAksNpScheduling): void;
    resetScheduling(): void;
    get schedulingInput(): OceanAksNpScheduling | undefined;
    private _taints;
    get taints(): OceanAksNpTaintsList;
    putTaints(value: OceanAksNpTaints[] | cdktf.IResolvable): void;
    resetTaints(): void;
    get taintsInput(): cdktf.IResolvable | OceanAksNpTaints[] | undefined;
    private _updatePolicy;
    get updatePolicy(): OceanAksNpUpdatePolicyOutputReference;
    putUpdatePolicy(value: OceanAksNpUpdatePolicy): void;
    resetUpdatePolicy(): void;
    get updatePolicyInput(): OceanAksNpUpdatePolicy | undefined;
    private _vngTemplateScheduling;
    get vngTemplateScheduling(): OceanAksNpVngTemplateSchedulingOutputReference;
    putVngTemplateScheduling(value: OceanAksNpVngTemplateScheduling): void;
    resetVngTemplateScheduling(): void;
    get vngTemplateSchedulingInput(): OceanAksNpVngTemplateScheduling | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
