/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OceancdRolloutSpecConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#id OceancdRolloutSpec#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#rollout_spec_name OceancdRolloutSpec#rollout_spec_name}
    */
    readonly rolloutSpecName: string;
    /**
    * failure_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#failure_policy OceancdRolloutSpec#failure_policy}
    */
    readonly failurePolicy?: OceancdRolloutSpecFailurePolicy;
    /**
    * spot_deployment block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#spot_deployment OceancdRolloutSpec#spot_deployment}
    */
    readonly spotDeployment?: OceancdRolloutSpecSpotDeployment;
    /**
    * spot_deployments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#spot_deployments OceancdRolloutSpec#spot_deployments}
    */
    readonly spotDeployments?: OceancdRolloutSpecSpotDeployments[] | cdktf.IResolvable;
    /**
    * strategy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#strategy OceancdRolloutSpec#strategy}
    */
    readonly strategy: OceancdRolloutSpecStrategy;
    /**
    * traffic block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#traffic OceancdRolloutSpec#traffic}
    */
    readonly traffic?: OceancdRolloutSpecTraffic;
}
export interface OceancdRolloutSpecFailurePolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#action OceancdRolloutSpec#action}
    */
    readonly action: string;
}
export declare function oceancdRolloutSpecFailurePolicyToTerraform(struct?: OceancdRolloutSpecFailurePolicyOutputReference | OceancdRolloutSpecFailurePolicy): any;
export declare function oceancdRolloutSpecFailurePolicyToHclTerraform(struct?: OceancdRolloutSpecFailurePolicyOutputReference | OceancdRolloutSpecFailurePolicy): any;
export declare class OceancdRolloutSpecFailurePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecFailurePolicy | undefined;
    set internalValue(value: OceancdRolloutSpecFailurePolicy | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    get actionInput(): string | undefined;
}
export interface OceancdRolloutSpecSpotDeployment {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#spot_deployment_cluster_id OceancdRolloutSpec#spot_deployment_cluster_id}
    */
    readonly spotDeploymentClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#spot_deployment_name OceancdRolloutSpec#spot_deployment_name}
    */
    readonly spotDeploymentName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#spot_deployment_namespace OceancdRolloutSpec#spot_deployment_namespace}
    */
    readonly spotDeploymentNamespace?: string;
}
export declare function oceancdRolloutSpecSpotDeploymentToTerraform(struct?: OceancdRolloutSpecSpotDeploymentOutputReference | OceancdRolloutSpecSpotDeployment): any;
export declare function oceancdRolloutSpecSpotDeploymentToHclTerraform(struct?: OceancdRolloutSpecSpotDeploymentOutputReference | OceancdRolloutSpecSpotDeployment): any;
export declare class OceancdRolloutSpecSpotDeploymentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecSpotDeployment | undefined;
    set internalValue(value: OceancdRolloutSpecSpotDeployment | undefined);
    private _spotDeploymentClusterId?;
    get spotDeploymentClusterId(): string;
    set spotDeploymentClusterId(value: string);
    resetSpotDeploymentClusterId(): void;
    get spotDeploymentClusterIdInput(): string | undefined;
    private _spotDeploymentName?;
    get spotDeploymentName(): string;
    set spotDeploymentName(value: string);
    resetSpotDeploymentName(): void;
    get spotDeploymentNameInput(): string | undefined;
    private _spotDeploymentNamespace?;
    get spotDeploymentNamespace(): string;
    set spotDeploymentNamespace(value: string);
    resetSpotDeploymentNamespace(): void;
    get spotDeploymentNamespaceInput(): string | undefined;
}
export interface OceancdRolloutSpecSpotDeployments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#spot_deployments_cluster_id OceancdRolloutSpec#spot_deployments_cluster_id}
    */
    readonly spotDeploymentsClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#spot_deployments_name OceancdRolloutSpec#spot_deployments_name}
    */
    readonly spotDeploymentsName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#spot_deployments_namespace OceancdRolloutSpec#spot_deployments_namespace}
    */
    readonly spotDeploymentsNamespace?: string;
}
export declare function oceancdRolloutSpecSpotDeploymentsToTerraform(struct?: OceancdRolloutSpecSpotDeployments | cdktf.IResolvable): any;
export declare function oceancdRolloutSpecSpotDeploymentsToHclTerraform(struct?: OceancdRolloutSpecSpotDeployments | cdktf.IResolvable): any;
export declare class OceancdRolloutSpecSpotDeploymentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdRolloutSpecSpotDeployments | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdRolloutSpecSpotDeployments | cdktf.IResolvable | undefined);
    private _spotDeploymentsClusterId?;
    get spotDeploymentsClusterId(): string;
    set spotDeploymentsClusterId(value: string);
    resetSpotDeploymentsClusterId(): void;
    get spotDeploymentsClusterIdInput(): string | undefined;
    private _spotDeploymentsName?;
    get spotDeploymentsName(): string;
    set spotDeploymentsName(value: string);
    resetSpotDeploymentsName(): void;
    get spotDeploymentsNameInput(): string | undefined;
    private _spotDeploymentsNamespace?;
    get spotDeploymentsNamespace(): string;
    set spotDeploymentsNamespace(value: string);
    resetSpotDeploymentsNamespace(): void;
    get spotDeploymentsNamespaceInput(): string | undefined;
}
export declare class OceancdRolloutSpecSpotDeploymentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdRolloutSpecSpotDeployments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdRolloutSpecSpotDeploymentsOutputReference;
}
export interface OceancdRolloutSpecStrategyArgsValueFromFieldRef {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#field_path OceancdRolloutSpec#field_path}
    */
    readonly fieldPath: string;
}
export declare function oceancdRolloutSpecStrategyArgsValueFromFieldRefToTerraform(struct?: OceancdRolloutSpecStrategyArgsValueFromFieldRefOutputReference | OceancdRolloutSpecStrategyArgsValueFromFieldRef): any;
export declare function oceancdRolloutSpecStrategyArgsValueFromFieldRefToHclTerraform(struct?: OceancdRolloutSpecStrategyArgsValueFromFieldRefOutputReference | OceancdRolloutSpecStrategyArgsValueFromFieldRef): any;
export declare class OceancdRolloutSpecStrategyArgsValueFromFieldRefOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecStrategyArgsValueFromFieldRef | undefined;
    set internalValue(value: OceancdRolloutSpecStrategyArgsValueFromFieldRef | undefined);
    private _fieldPath?;
    get fieldPath(): string;
    set fieldPath(value: string);
    get fieldPathInput(): string | undefined;
}
export interface OceancdRolloutSpecStrategyArgsValueFrom {
    /**
    * field_ref block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#field_ref OceancdRolloutSpec#field_ref}
    */
    readonly fieldRef: OceancdRolloutSpecStrategyArgsValueFromFieldRef;
}
export declare function oceancdRolloutSpecStrategyArgsValueFromToTerraform(struct?: OceancdRolloutSpecStrategyArgsValueFromOutputReference | OceancdRolloutSpecStrategyArgsValueFrom): any;
export declare function oceancdRolloutSpecStrategyArgsValueFromToHclTerraform(struct?: OceancdRolloutSpecStrategyArgsValueFromOutputReference | OceancdRolloutSpecStrategyArgsValueFrom): any;
export declare class OceancdRolloutSpecStrategyArgsValueFromOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecStrategyArgsValueFrom | undefined;
    set internalValue(value: OceancdRolloutSpecStrategyArgsValueFrom | undefined);
    private _fieldRef;
    get fieldRef(): OceancdRolloutSpecStrategyArgsValueFromFieldRefOutputReference;
    putFieldRef(value: OceancdRolloutSpecStrategyArgsValueFromFieldRef): void;
    get fieldRefInput(): OceancdRolloutSpecStrategyArgsValueFromFieldRef | undefined;
}
export interface OceancdRolloutSpecStrategyArgs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#arg_name OceancdRolloutSpec#arg_name}
    */
    readonly argName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#arg_value OceancdRolloutSpec#arg_value}
    */
    readonly argValue?: string;
    /**
    * value_from block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#value_from OceancdRolloutSpec#value_from}
    */
    readonly valueFrom?: OceancdRolloutSpecStrategyArgsValueFrom;
}
export declare function oceancdRolloutSpecStrategyArgsToTerraform(struct?: OceancdRolloutSpecStrategyArgs | cdktf.IResolvable): any;
export declare function oceancdRolloutSpecStrategyArgsToHclTerraform(struct?: OceancdRolloutSpecStrategyArgs | cdktf.IResolvable): any;
export declare class OceancdRolloutSpecStrategyArgsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdRolloutSpecStrategyArgs | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdRolloutSpecStrategyArgs | cdktf.IResolvable | undefined);
    private _argName?;
    get argName(): string;
    set argName(value: string);
    get argNameInput(): string | undefined;
    private _argValue?;
    get argValue(): string;
    set argValue(value: string);
    resetArgValue(): void;
    get argValueInput(): string | undefined;
    private _valueFrom;
    get valueFrom(): OceancdRolloutSpecStrategyArgsValueFromOutputReference;
    putValueFrom(value: OceancdRolloutSpecStrategyArgsValueFrom): void;
    resetValueFrom(): void;
    get valueFromInput(): OceancdRolloutSpecStrategyArgsValueFrom | undefined;
}
export declare class OceancdRolloutSpecStrategyArgsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdRolloutSpecStrategyArgs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdRolloutSpecStrategyArgsOutputReference;
}
export interface OceancdRolloutSpecStrategy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#strategy_name OceancdRolloutSpec#strategy_name}
    */
    readonly strategyName: string;
    /**
    * args block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#args OceancdRolloutSpec#args}
    */
    readonly args?: OceancdRolloutSpecStrategyArgs[] | cdktf.IResolvable;
}
export declare function oceancdRolloutSpecStrategyToTerraform(struct?: OceancdRolloutSpecStrategyOutputReference | OceancdRolloutSpecStrategy): any;
export declare function oceancdRolloutSpecStrategyToHclTerraform(struct?: OceancdRolloutSpecStrategyOutputReference | OceancdRolloutSpecStrategy): any;
export declare class OceancdRolloutSpecStrategyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecStrategy | undefined;
    set internalValue(value: OceancdRolloutSpecStrategy | undefined);
    private _strategyName?;
    get strategyName(): string;
    set strategyName(value: string);
    get strategyNameInput(): string | undefined;
    private _args;
    get args(): OceancdRolloutSpecStrategyArgsList;
    putArgs(value: OceancdRolloutSpecStrategyArgs[] | cdktf.IResolvable): void;
    resetArgs(): void;
    get argsInput(): cdktf.IResolvable | OceancdRolloutSpecStrategyArgs[] | undefined;
}
export interface OceancdRolloutSpecTrafficAlbStickinessConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#duration_seconds OceancdRolloutSpec#duration_seconds}
    */
    readonly durationSeconds?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#enabled OceancdRolloutSpec#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
}
export declare function oceancdRolloutSpecTrafficAlbStickinessConfigToTerraform(struct?: OceancdRolloutSpecTrafficAlbStickinessConfigOutputReference | OceancdRolloutSpecTrafficAlbStickinessConfig): any;
export declare function oceancdRolloutSpecTrafficAlbStickinessConfigToHclTerraform(struct?: OceancdRolloutSpecTrafficAlbStickinessConfigOutputReference | OceancdRolloutSpecTrafficAlbStickinessConfig): any;
export declare class OceancdRolloutSpecTrafficAlbStickinessConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficAlbStickinessConfig | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficAlbStickinessConfig | undefined);
    private _durationSeconds?;
    get durationSeconds(): number;
    set durationSeconds(value: number);
    resetDurationSeconds(): void;
    get durationSecondsInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface OceancdRolloutSpecTrafficAlb {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#alb_annotation_prefix OceancdRolloutSpec#alb_annotation_prefix}
    */
    readonly albAnnotationPrefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#alb_ingress OceancdRolloutSpec#alb_ingress}
    */
    readonly albIngress: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#alb_root_service OceancdRolloutSpec#alb_root_service}
    */
    readonly albRootService: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#service_port OceancdRolloutSpec#service_port}
    */
    readonly servicePort: number;
    /**
    * stickiness_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#stickiness_config OceancdRolloutSpec#stickiness_config}
    */
    readonly stickinessConfig?: OceancdRolloutSpecTrafficAlbStickinessConfig;
}
export declare function oceancdRolloutSpecTrafficAlbToTerraform(struct?: OceancdRolloutSpecTrafficAlbOutputReference | OceancdRolloutSpecTrafficAlb): any;
export declare function oceancdRolloutSpecTrafficAlbToHclTerraform(struct?: OceancdRolloutSpecTrafficAlbOutputReference | OceancdRolloutSpecTrafficAlb): any;
export declare class OceancdRolloutSpecTrafficAlbOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficAlb | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficAlb | undefined);
    private _albAnnotationPrefix?;
    get albAnnotationPrefix(): string;
    set albAnnotationPrefix(value: string);
    resetAlbAnnotationPrefix(): void;
    get albAnnotationPrefixInput(): string | undefined;
    private _albIngress?;
    get albIngress(): string;
    set albIngress(value: string);
    get albIngressInput(): string | undefined;
    private _albRootService?;
    get albRootService(): string;
    set albRootService(value: string);
    get albRootServiceInput(): string | undefined;
    private _servicePort?;
    get servicePort(): number;
    set servicePort(value: number);
    get servicePortInput(): number | undefined;
    private _stickinessConfig;
    get stickinessConfig(): OceancdRolloutSpecTrafficAlbStickinessConfigOutputReference;
    putStickinessConfig(value: OceancdRolloutSpecTrafficAlbStickinessConfig): void;
    resetStickinessConfig(): void;
    get stickinessConfigInput(): OceancdRolloutSpecTrafficAlbStickinessConfig | undefined;
}
export interface OceancdRolloutSpecTrafficAmbassador {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#mappings OceancdRolloutSpec#mappings}
    */
    readonly mappings: string[];
}
export declare function oceancdRolloutSpecTrafficAmbassadorToTerraform(struct?: OceancdRolloutSpecTrafficAmbassadorOutputReference | OceancdRolloutSpecTrafficAmbassador): any;
export declare function oceancdRolloutSpecTrafficAmbassadorToHclTerraform(struct?: OceancdRolloutSpecTrafficAmbassadorOutputReference | OceancdRolloutSpecTrafficAmbassador): any;
export declare class OceancdRolloutSpecTrafficAmbassadorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficAmbassador | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficAmbassador | undefined);
    private _mappings?;
    get mappings(): string[];
    set mappings(value: string[]);
    get mappingsInput(): string[] | undefined;
}
export interface OceancdRolloutSpecTrafficIstioDestinationRule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#canary_subset_name OceancdRolloutSpec#canary_subset_name}
    */
    readonly canarySubsetName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#destination_rule_name OceancdRolloutSpec#destination_rule_name}
    */
    readonly destinationRuleName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#stable_subset_name OceancdRolloutSpec#stable_subset_name}
    */
    readonly stableSubsetName: string;
}
export declare function oceancdRolloutSpecTrafficIstioDestinationRuleToTerraform(struct?: OceancdRolloutSpecTrafficIstioDestinationRuleOutputReference | OceancdRolloutSpecTrafficIstioDestinationRule): any;
export declare function oceancdRolloutSpecTrafficIstioDestinationRuleToHclTerraform(struct?: OceancdRolloutSpecTrafficIstioDestinationRuleOutputReference | OceancdRolloutSpecTrafficIstioDestinationRule): any;
export declare class OceancdRolloutSpecTrafficIstioDestinationRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficIstioDestinationRule | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficIstioDestinationRule | undefined);
    private _canarySubsetName?;
    get canarySubsetName(): string;
    set canarySubsetName(value: string);
    get canarySubsetNameInput(): string | undefined;
    private _destinationRuleName?;
    get destinationRuleName(): string;
    set destinationRuleName(value: string);
    get destinationRuleNameInput(): string | undefined;
    private _stableSubsetName?;
    get stableSubsetName(): string;
    set stableSubsetName(value: string);
    get stableSubsetNameInput(): string | undefined;
}
export interface OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#port OceancdRolloutSpec#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#sni_hosts OceancdRolloutSpec#sni_hosts}
    */
    readonly sniHosts?: string[];
}
export declare function oceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutesToTerraform(struct?: OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes | cdktf.IResolvable): any;
export declare function oceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutesToHclTerraform(struct?: OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes | cdktf.IResolvable): any;
export declare class OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes | cdktf.IResolvable | undefined);
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _sniHosts?;
    get sniHosts(): string[];
    set sniHosts(value: string[]);
    resetSniHosts(): void;
    get sniHostsInput(): string[] | undefined;
}
export declare class OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutesOutputReference;
}
export interface OceancdRolloutSpecTrafficIstioVirtualServices {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#virtual_service_name OceancdRolloutSpec#virtual_service_name}
    */
    readonly virtualServiceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#virtual_service_routes OceancdRolloutSpec#virtual_service_routes}
    */
    readonly virtualServiceRoutes?: string[];
    /**
    * tls_routes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#tls_routes OceancdRolloutSpec#tls_routes}
    */
    readonly tlsRoutes?: OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes[] | cdktf.IResolvable;
}
export declare function oceancdRolloutSpecTrafficIstioVirtualServicesToTerraform(struct?: OceancdRolloutSpecTrafficIstioVirtualServices | cdktf.IResolvable): any;
export declare function oceancdRolloutSpecTrafficIstioVirtualServicesToHclTerraform(struct?: OceancdRolloutSpecTrafficIstioVirtualServices | cdktf.IResolvable): any;
export declare class OceancdRolloutSpecTrafficIstioVirtualServicesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdRolloutSpecTrafficIstioVirtualServices | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficIstioVirtualServices | cdktf.IResolvable | undefined);
    private _virtualServiceName?;
    get virtualServiceName(): string;
    set virtualServiceName(value: string);
    get virtualServiceNameInput(): string | undefined;
    private _virtualServiceRoutes?;
    get virtualServiceRoutes(): string[];
    set virtualServiceRoutes(value: string[]);
    resetVirtualServiceRoutes(): void;
    get virtualServiceRoutesInput(): string[] | undefined;
    private _tlsRoutes;
    get tlsRoutes(): OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutesList;
    putTlsRoutes(value: OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes[] | cdktf.IResolvable): void;
    resetTlsRoutes(): void;
    get tlsRoutesInput(): cdktf.IResolvable | OceancdRolloutSpecTrafficIstioVirtualServicesTlsRoutes[] | undefined;
}
export declare class OceancdRolloutSpecTrafficIstioVirtualServicesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdRolloutSpecTrafficIstioVirtualServices[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdRolloutSpecTrafficIstioVirtualServicesOutputReference;
}
export interface OceancdRolloutSpecTrafficIstio {
    /**
    * destination_rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#destination_rule OceancdRolloutSpec#destination_rule}
    */
    readonly destinationRule?: OceancdRolloutSpecTrafficIstioDestinationRule;
    /**
    * virtual_services block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#virtual_services OceancdRolloutSpec#virtual_services}
    */
    readonly virtualServices: OceancdRolloutSpecTrafficIstioVirtualServices[] | cdktf.IResolvable;
}
export declare function oceancdRolloutSpecTrafficIstioToTerraform(struct?: OceancdRolloutSpecTrafficIstioOutputReference | OceancdRolloutSpecTrafficIstio): any;
export declare function oceancdRolloutSpecTrafficIstioToHclTerraform(struct?: OceancdRolloutSpecTrafficIstioOutputReference | OceancdRolloutSpecTrafficIstio): any;
export declare class OceancdRolloutSpecTrafficIstioOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficIstio | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficIstio | undefined);
    private _destinationRule;
    get destinationRule(): OceancdRolloutSpecTrafficIstioDestinationRuleOutputReference;
    putDestinationRule(value: OceancdRolloutSpecTrafficIstioDestinationRule): void;
    resetDestinationRule(): void;
    get destinationRuleInput(): OceancdRolloutSpecTrafficIstioDestinationRule | undefined;
    private _virtualServices;
    get virtualServices(): OceancdRolloutSpecTrafficIstioVirtualServicesList;
    putVirtualServices(value: OceancdRolloutSpecTrafficIstioVirtualServices[] | cdktf.IResolvable): void;
    get virtualServicesInput(): cdktf.IResolvable | OceancdRolloutSpecTrafficIstioVirtualServices[] | undefined;
}
export interface OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotation {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#canary_by_header OceancdRolloutSpec#canary_by_header}
    */
    readonly canaryByHeader?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#key1 OceancdRolloutSpec#key1}
    */
    readonly key1?: string;
}
export declare function oceancdRolloutSpecTrafficNginxAdditionalIngressAnnotationToTerraform(struct?: OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotationOutputReference | OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotation): any;
export declare function oceancdRolloutSpecTrafficNginxAdditionalIngressAnnotationToHclTerraform(struct?: OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotationOutputReference | OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotation): any;
export declare class OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotation | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotation | undefined);
    private _canaryByHeader?;
    get canaryByHeader(): string;
    set canaryByHeader(value: string);
    resetCanaryByHeader(): void;
    get canaryByHeaderInput(): string | undefined;
    private _key1?;
    get key1(): string;
    set key1(value: string);
    resetKey1(): void;
    get key1Input(): string | undefined;
}
export interface OceancdRolloutSpecTrafficNginx {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#nginx_annotation_prefix OceancdRolloutSpec#nginx_annotation_prefix}
    */
    readonly nginxAnnotationPrefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#stable_ingress OceancdRolloutSpec#stable_ingress}
    */
    readonly stableIngress: string;
    /**
    * additional_ingress_annotation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#additional_ingress_annotation OceancdRolloutSpec#additional_ingress_annotation}
    */
    readonly additionalIngressAnnotation?: OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotation;
}
export declare function oceancdRolloutSpecTrafficNginxToTerraform(struct?: OceancdRolloutSpecTrafficNginxOutputReference | OceancdRolloutSpecTrafficNginx): any;
export declare function oceancdRolloutSpecTrafficNginxToHclTerraform(struct?: OceancdRolloutSpecTrafficNginxOutputReference | OceancdRolloutSpecTrafficNginx): any;
export declare class OceancdRolloutSpecTrafficNginxOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficNginx | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficNginx | undefined);
    private _nginxAnnotationPrefix?;
    get nginxAnnotationPrefix(): string;
    set nginxAnnotationPrefix(value: string);
    resetNginxAnnotationPrefix(): void;
    get nginxAnnotationPrefixInput(): string | undefined;
    private _stableIngress?;
    get stableIngress(): string;
    set stableIngress(value: string);
    get stableIngressInput(): string | undefined;
    private _additionalIngressAnnotation;
    get additionalIngressAnnotation(): OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotationOutputReference;
    putAdditionalIngressAnnotation(value: OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotation): void;
    resetAdditionalIngressAnnotation(): void;
    get additionalIngressAnnotationInput(): OceancdRolloutSpecTrafficNginxAdditionalIngressAnnotation | undefined;
}
export interface OceancdRolloutSpecTrafficPingPong {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#ping_service OceancdRolloutSpec#ping_service}
    */
    readonly pingService: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#pong_service OceancdRolloutSpec#pong_service}
    */
    readonly pongService: string;
}
export declare function oceancdRolloutSpecTrafficPingPongToTerraform(struct?: OceancdRolloutSpecTrafficPingPongOutputReference | OceancdRolloutSpecTrafficPingPong): any;
export declare function oceancdRolloutSpecTrafficPingPongToHclTerraform(struct?: OceancdRolloutSpecTrafficPingPongOutputReference | OceancdRolloutSpecTrafficPingPong): any;
export declare class OceancdRolloutSpecTrafficPingPongOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficPingPong | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficPingPong | undefined);
    private _pingService?;
    get pingService(): string;
    set pingService(value: string);
    get pingServiceInput(): string | undefined;
    private _pongService?;
    get pongService(): string;
    set pongService(value: string);
    get pongServiceInput(): string | undefined;
}
export interface OceancdRolloutSpecTrafficSmi {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#smi_root_service OceancdRolloutSpec#smi_root_service}
    */
    readonly smiRootService?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#traffic_split_name OceancdRolloutSpec#traffic_split_name}
    */
    readonly trafficSplitName?: string;
}
export declare function oceancdRolloutSpecTrafficSmiToTerraform(struct?: OceancdRolloutSpecTrafficSmiOutputReference | OceancdRolloutSpecTrafficSmi): any;
export declare function oceancdRolloutSpecTrafficSmiToHclTerraform(struct?: OceancdRolloutSpecTrafficSmiOutputReference | OceancdRolloutSpecTrafficSmi): any;
export declare class OceancdRolloutSpecTrafficSmiOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTrafficSmi | undefined;
    set internalValue(value: OceancdRolloutSpecTrafficSmi | undefined);
    private _smiRootService?;
    get smiRootService(): string;
    set smiRootService(value: string);
    resetSmiRootService(): void;
    get smiRootServiceInput(): string | undefined;
    private _trafficSplitName?;
    get trafficSplitName(): string;
    set trafficSplitName(value: string);
    resetTrafficSplitName(): void;
    get trafficSplitNameInput(): string | undefined;
}
export interface OceancdRolloutSpecTraffic {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#canary_service OceancdRolloutSpec#canary_service}
    */
    readonly canaryService?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#stable_service OceancdRolloutSpec#stable_service}
    */
    readonly stableService?: string;
    /**
    * alb block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#alb OceancdRolloutSpec#alb}
    */
    readonly alb?: OceancdRolloutSpecTrafficAlb;
    /**
    * ambassador block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#ambassador OceancdRolloutSpec#ambassador}
    */
    readonly ambassador?: OceancdRolloutSpecTrafficAmbassador;
    /**
    * istio block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#istio OceancdRolloutSpec#istio}
    */
    readonly istio?: OceancdRolloutSpecTrafficIstio;
    /**
    * nginx block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#nginx OceancdRolloutSpec#nginx}
    */
    readonly nginx?: OceancdRolloutSpecTrafficNginx;
    /**
    * ping_pong block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#ping_pong OceancdRolloutSpec#ping_pong}
    */
    readonly pingPong?: OceancdRolloutSpecTrafficPingPong;
    /**
    * smi block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#smi OceancdRolloutSpec#smi}
    */
    readonly smi?: OceancdRolloutSpecTrafficSmi;
}
export declare function oceancdRolloutSpecTrafficToTerraform(struct?: OceancdRolloutSpecTrafficOutputReference | OceancdRolloutSpecTraffic): any;
export declare function oceancdRolloutSpecTrafficToHclTerraform(struct?: OceancdRolloutSpecTrafficOutputReference | OceancdRolloutSpecTraffic): any;
export declare class OceancdRolloutSpecTrafficOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdRolloutSpecTraffic | undefined;
    set internalValue(value: OceancdRolloutSpecTraffic | undefined);
    private _canaryService?;
    get canaryService(): string;
    set canaryService(value: string);
    resetCanaryService(): void;
    get canaryServiceInput(): string | undefined;
    private _stableService?;
    get stableService(): string;
    set stableService(value: string);
    resetStableService(): void;
    get stableServiceInput(): string | undefined;
    private _alb;
    get alb(): OceancdRolloutSpecTrafficAlbOutputReference;
    putAlb(value: OceancdRolloutSpecTrafficAlb): void;
    resetAlb(): void;
    get albInput(): OceancdRolloutSpecTrafficAlb | undefined;
    private _ambassador;
    get ambassador(): OceancdRolloutSpecTrafficAmbassadorOutputReference;
    putAmbassador(value: OceancdRolloutSpecTrafficAmbassador): void;
    resetAmbassador(): void;
    get ambassadorInput(): OceancdRolloutSpecTrafficAmbassador | undefined;
    private _istio;
    get istio(): OceancdRolloutSpecTrafficIstioOutputReference;
    putIstio(value: OceancdRolloutSpecTrafficIstio): void;
    resetIstio(): void;
    get istioInput(): OceancdRolloutSpecTrafficIstio | undefined;
    private _nginx;
    get nginx(): OceancdRolloutSpecTrafficNginxOutputReference;
    putNginx(value: OceancdRolloutSpecTrafficNginx): void;
    resetNginx(): void;
    get nginxInput(): OceancdRolloutSpecTrafficNginx | undefined;
    private _pingPong;
    get pingPong(): OceancdRolloutSpecTrafficPingPongOutputReference;
    putPingPong(value: OceancdRolloutSpecTrafficPingPong): void;
    resetPingPong(): void;
    get pingPongInput(): OceancdRolloutSpecTrafficPingPong | undefined;
    private _smi;
    get smi(): OceancdRolloutSpecTrafficSmiOutputReference;
    putSmi(value: OceancdRolloutSpecTrafficSmi): void;
    resetSmi(): void;
    get smiInput(): OceancdRolloutSpecTrafficSmi | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec spotinst_oceancd_rollout_spec}
*/
export declare class OceancdRolloutSpec extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_oceancd_rollout_spec";
    /**
    * Generates CDKTF code for importing a OceancdRolloutSpec resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OceancdRolloutSpec to import
    * @param importFromId The id of the existing OceancdRolloutSpec that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OceancdRolloutSpec to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_rollout_spec spotinst_oceancd_rollout_spec} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OceancdRolloutSpecConfig
    */
    constructor(scope: Construct, id: string, config: OceancdRolloutSpecConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _rolloutSpecName?;
    get rolloutSpecName(): string;
    set rolloutSpecName(value: string);
    get rolloutSpecNameInput(): string | undefined;
    private _failurePolicy;
    get failurePolicy(): OceancdRolloutSpecFailurePolicyOutputReference;
    putFailurePolicy(value: OceancdRolloutSpecFailurePolicy): void;
    resetFailurePolicy(): void;
    get failurePolicyInput(): OceancdRolloutSpecFailurePolicy | undefined;
    private _spotDeployment;
    get spotDeployment(): OceancdRolloutSpecSpotDeploymentOutputReference;
    putSpotDeployment(value: OceancdRolloutSpecSpotDeployment): void;
    resetSpotDeployment(): void;
    get spotDeploymentInput(): OceancdRolloutSpecSpotDeployment | undefined;
    private _spotDeployments;
    get spotDeployments(): OceancdRolloutSpecSpotDeploymentsList;
    putSpotDeployments(value: OceancdRolloutSpecSpotDeployments[] | cdktf.IResolvable): void;
    resetSpotDeployments(): void;
    get spotDeploymentsInput(): cdktf.IResolvable | OceancdRolloutSpecSpotDeployments[] | undefined;
    private _strategy;
    get strategy(): OceancdRolloutSpecStrategyOutputReference;
    putStrategy(value: OceancdRolloutSpecStrategy): void;
    get strategyInput(): OceancdRolloutSpecStrategy | undefined;
    private _traffic;
    get traffic(): OceancdRolloutSpecTrafficOutputReference;
    putTraffic(value: OceancdRolloutSpecTraffic): void;
    resetTraffic(): void;
    get trafficInput(): OceancdRolloutSpecTraffic | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
