/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OceancdVerificationProviderConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#cluster_ids OceancdVerificationProvider#cluster_ids}
    */
    readonly clusterIds: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#id OceancdVerificationProvider#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#name OceancdVerificationProvider#name}
    */
    readonly name: string;
    /**
    * cloud_watch block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#cloud_watch OceancdVerificationProvider#cloud_watch}
    */
    readonly cloudWatch?: OceancdVerificationProviderCloudWatch;
    /**
    * datadog block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#datadog OceancdVerificationProvider#datadog}
    */
    readonly datadog?: OceancdVerificationProviderDatadog;
    /**
    * jenkins block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#jenkins OceancdVerificationProvider#jenkins}
    */
    readonly jenkins?: OceancdVerificationProviderJenkins;
    /**
    * new_relic block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#new_relic OceancdVerificationProvider#new_relic}
    */
    readonly newRelic?: OceancdVerificationProviderNewRelic;
    /**
    * prometheus block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#prometheus OceancdVerificationProvider#prometheus}
    */
    readonly prometheus?: OceancdVerificationProviderPrometheus;
}
export interface OceancdVerificationProviderCloudWatch {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#iam_arn OceancdVerificationProvider#iam_arn}
    */
    readonly iamArn: string;
}
export declare function oceancdVerificationProviderCloudWatchToTerraform(struct?: OceancdVerificationProviderCloudWatchOutputReference | OceancdVerificationProviderCloudWatch): any;
export declare function oceancdVerificationProviderCloudWatchToHclTerraform(struct?: OceancdVerificationProviderCloudWatchOutputReference | OceancdVerificationProviderCloudWatch): any;
export declare class OceancdVerificationProviderCloudWatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationProviderCloudWatch | undefined;
    set internalValue(value: OceancdVerificationProviderCloudWatch | undefined);
    private _iamArn?;
    get iamArn(): string;
    set iamArn(value: string);
    get iamArnInput(): string | undefined;
}
export interface OceancdVerificationProviderDatadog {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#address OceancdVerificationProvider#address}
    */
    readonly address: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#api_key OceancdVerificationProvider#api_key}
    */
    readonly apiKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#app_key OceancdVerificationProvider#app_key}
    */
    readonly appKey: string;
}
export declare function oceancdVerificationProviderDatadogToTerraform(struct?: OceancdVerificationProviderDatadogOutputReference | OceancdVerificationProviderDatadog): any;
export declare function oceancdVerificationProviderDatadogToHclTerraform(struct?: OceancdVerificationProviderDatadogOutputReference | OceancdVerificationProviderDatadog): any;
export declare class OceancdVerificationProviderDatadogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationProviderDatadog | undefined;
    set internalValue(value: OceancdVerificationProviderDatadog | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    get addressInput(): string | undefined;
    private _apiKey?;
    get apiKey(): string;
    set apiKey(value: string);
    get apiKeyInput(): string | undefined;
    private _appKey?;
    get appKey(): string;
    set appKey(value: string);
    get appKeyInput(): string | undefined;
}
export interface OceancdVerificationProviderJenkins {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#api_token OceancdVerificationProvider#api_token}
    */
    readonly apiToken: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#base_url OceancdVerificationProvider#base_url}
    */
    readonly baseUrl: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#username OceancdVerificationProvider#username}
    */
    readonly username: string;
}
export declare function oceancdVerificationProviderJenkinsToTerraform(struct?: OceancdVerificationProviderJenkinsOutputReference | OceancdVerificationProviderJenkins): any;
export declare function oceancdVerificationProviderJenkinsToHclTerraform(struct?: OceancdVerificationProviderJenkinsOutputReference | OceancdVerificationProviderJenkins): any;
export declare class OceancdVerificationProviderJenkinsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationProviderJenkins | undefined;
    set internalValue(value: OceancdVerificationProviderJenkins | undefined);
    private _apiToken?;
    get apiToken(): string;
    set apiToken(value: string);
    get apiTokenInput(): string | undefined;
    private _baseUrl?;
    get baseUrl(): string;
    set baseUrl(value: string);
    get baseUrlInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    get usernameInput(): string | undefined;
}
export interface OceancdVerificationProviderNewRelic {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#account_id OceancdVerificationProvider#account_id}
    */
    readonly accountId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#base_url_nerd_graph OceancdVerificationProvider#base_url_nerd_graph}
    */
    readonly baseUrlNerdGraph?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#base_url_rest OceancdVerificationProvider#base_url_rest}
    */
    readonly baseUrlRest?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#personal_api_key OceancdVerificationProvider#personal_api_key}
    */
    readonly personalApiKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#region OceancdVerificationProvider#region}
    */
    readonly region?: string;
}
export declare function oceancdVerificationProviderNewRelicToTerraform(struct?: OceancdVerificationProviderNewRelicOutputReference | OceancdVerificationProviderNewRelic): any;
export declare function oceancdVerificationProviderNewRelicToHclTerraform(struct?: OceancdVerificationProviderNewRelicOutputReference | OceancdVerificationProviderNewRelic): any;
export declare class OceancdVerificationProviderNewRelicOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationProviderNewRelic | undefined;
    set internalValue(value: OceancdVerificationProviderNewRelic | undefined);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _baseUrlNerdGraph?;
    get baseUrlNerdGraph(): string;
    set baseUrlNerdGraph(value: string);
    resetBaseUrlNerdGraph(): void;
    get baseUrlNerdGraphInput(): string | undefined;
    private _baseUrlRest?;
    get baseUrlRest(): string;
    set baseUrlRest(value: string);
    resetBaseUrlRest(): void;
    get baseUrlRestInput(): string | undefined;
    private _personalApiKey?;
    get personalApiKey(): string;
    set personalApiKey(value: string);
    get personalApiKeyInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
}
export interface OceancdVerificationProviderPrometheus {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#address OceancdVerificationProvider#address}
    */
    readonly address: string;
}
export declare function oceancdVerificationProviderPrometheusToTerraform(struct?: OceancdVerificationProviderPrometheusOutputReference | OceancdVerificationProviderPrometheus): any;
export declare function oceancdVerificationProviderPrometheusToHclTerraform(struct?: OceancdVerificationProviderPrometheusOutputReference | OceancdVerificationProviderPrometheus): any;
export declare class OceancdVerificationProviderPrometheusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationProviderPrometheus | undefined;
    set internalValue(value: OceancdVerificationProviderPrometheus | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    get addressInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider spotinst_oceancd_verification_provider}
*/
export declare class OceancdVerificationProvider extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_oceancd_verification_provider";
    /**
    * Generates CDKTF code for importing a OceancdVerificationProvider resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OceancdVerificationProvider to import
    * @param importFromId The id of the existing OceancdVerificationProvider that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OceancdVerificationProvider to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/oceancd_verification_provider spotinst_oceancd_verification_provider} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OceancdVerificationProviderConfig
    */
    constructor(scope: Construct, id: string, config: OceancdVerificationProviderConfig);
    private _clusterIds?;
    get clusterIds(): string[];
    set clusterIds(value: string[]);
    get clusterIdsInput(): string[] | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _cloudWatch;
    get cloudWatch(): OceancdVerificationProviderCloudWatchOutputReference;
    putCloudWatch(value: OceancdVerificationProviderCloudWatch): void;
    resetCloudWatch(): void;
    get cloudWatchInput(): OceancdVerificationProviderCloudWatch | undefined;
    private _datadog;
    get datadog(): OceancdVerificationProviderDatadogOutputReference;
    putDatadog(value: OceancdVerificationProviderDatadog): void;
    resetDatadog(): void;
    get datadogInput(): OceancdVerificationProviderDatadog | undefined;
    private _jenkins;
    get jenkins(): OceancdVerificationProviderJenkinsOutputReference;
    putJenkins(value: OceancdVerificationProviderJenkins): void;
    resetJenkins(): void;
    get jenkinsInput(): OceancdVerificationProviderJenkins | undefined;
    private _newRelic;
    get newRelic(): OceancdVerificationProviderNewRelicOutputReference;
    putNewRelic(value: OceancdVerificationProviderNewRelic): void;
    resetNewRelic(): void;
    get newRelicInput(): OceancdVerificationProviderNewRelic | undefined;
    private _prometheus;
    get prometheus(): OceancdVerificationProviderPrometheusOutputReference;
    putPrometheus(value: OceancdVerificationProviderPrometheus): void;
    resetPrometheus(): void;
    get prometheusInput(): OceancdVerificationProviderPrometheus | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
