/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OrganizationProgrammaticUserConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#description OrganizationProgrammaticUser#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#id OrganizationProgrammaticUser#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#name OrganizationProgrammaticUser#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#user_group_ids OrganizationProgrammaticUser#user_group_ids}
    */
    readonly userGroupIds?: string[];
    /**
    * accounts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#accounts OrganizationProgrammaticUser#accounts}
    */
    readonly accounts?: OrganizationProgrammaticUserAccounts[] | cdktf.IResolvable;
    /**
    * policies block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#policies OrganizationProgrammaticUser#policies}
    */
    readonly policies?: OrganizationProgrammaticUserPolicies[] | cdktf.IResolvable;
}
export interface OrganizationProgrammaticUserAccounts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#account_id OrganizationProgrammaticUser#account_id}
    */
    readonly accountId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#account_role OrganizationProgrammaticUser#account_role}
    */
    readonly accountRole: string;
}
export declare function organizationProgrammaticUserAccountsToTerraform(struct?: OrganizationProgrammaticUserAccounts | cdktf.IResolvable): any;
export declare function organizationProgrammaticUserAccountsToHclTerraform(struct?: OrganizationProgrammaticUserAccounts | cdktf.IResolvable): any;
export declare class OrganizationProgrammaticUserAccountsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OrganizationProgrammaticUserAccounts | cdktf.IResolvable | undefined;
    set internalValue(value: OrganizationProgrammaticUserAccounts | cdktf.IResolvable | undefined);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _accountRole?;
    get accountRole(): string;
    set accountRole(value: string);
    get accountRoleInput(): string | undefined;
}
export declare class OrganizationProgrammaticUserAccountsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OrganizationProgrammaticUserAccounts[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OrganizationProgrammaticUserAccountsOutputReference;
}
export interface OrganizationProgrammaticUserPolicies {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#policy_account_ids OrganizationProgrammaticUser#policy_account_ids}
    */
    readonly policyAccountIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#policy_id OrganizationProgrammaticUser#policy_id}
    */
    readonly policyId: string;
}
export declare function organizationProgrammaticUserPoliciesToTerraform(struct?: OrganizationProgrammaticUserPolicies | cdktf.IResolvable): any;
export declare function organizationProgrammaticUserPoliciesToHclTerraform(struct?: OrganizationProgrammaticUserPolicies | cdktf.IResolvable): any;
export declare class OrganizationProgrammaticUserPoliciesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OrganizationProgrammaticUserPolicies | cdktf.IResolvable | undefined;
    set internalValue(value: OrganizationProgrammaticUserPolicies | cdktf.IResolvable | undefined);
    private _policyAccountIds?;
    get policyAccountIds(): string[];
    set policyAccountIds(value: string[]);
    resetPolicyAccountIds(): void;
    get policyAccountIdsInput(): string[] | undefined;
    private _policyId?;
    get policyId(): string;
    set policyId(value: string);
    get policyIdInput(): string | undefined;
}
export declare class OrganizationProgrammaticUserPoliciesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OrganizationProgrammaticUserPolicies[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OrganizationProgrammaticUserPoliciesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user spotinst_organization_programmatic_user}
*/
export declare class OrganizationProgrammaticUser extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_organization_programmatic_user";
    /**
    * Generates CDKTF code for importing a OrganizationProgrammaticUser resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OrganizationProgrammaticUser to import
    * @param importFromId The id of the existing OrganizationProgrammaticUser that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OrganizationProgrammaticUser to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.220.2/docs/resources/organization_programmatic_user spotinst_organization_programmatic_user} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OrganizationProgrammaticUserConfig
    */
    constructor(scope: Construct, id: string, config: OrganizationProgrammaticUserConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _userGroupIds?;
    get userGroupIds(): string[];
    set userGroupIds(value: string[]);
    resetUserGroupIds(): void;
    get userGroupIdsInput(): string[] | undefined;
    private _accounts;
    get accounts(): OrganizationProgrammaticUserAccountsList;
    putAccounts(value: OrganizationProgrammaticUserAccounts[] | cdktf.IResolvable): void;
    resetAccounts(): void;
    get accountsInput(): cdktf.IResolvable | OrganizationProgrammaticUserAccounts[] | undefined;
    private _policies;
    get policies(): OrganizationProgrammaticUserPoliciesList;
    putPolicies(value: OrganizationProgrammaticUserPolicies[] | cdktf.IResolvable): void;
    resetPolicies(): void;
    get policiesInput(): cdktf.IResolvable | OrganizationProgrammaticUserPolicies[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
